 ***************************************************************
 *  SPR2SCX.prg  (main prg)                                    *
 *  program by : MuPengYi (Email:mupengyi@371.net)             *                         *
 *  date       : 1999/07/10                                    *
 *  Purpos     : used to convert *.spr to *.scx/sct AND *.mpr  *
 *               to *.mnx/mnt  for easy Visual EDIT            *
 *  Note       : this file is a part of <UnFoxall>             *
 *  Usage:     : Do Spr2scx With 'd:\mypath\'                  *
 ***************************************************************


 PARAMETER mypath && parameter is *.spr/mpr(created with Unfoxall)'s
                     && path,example: do spr2scx with 'd:\001\'
 if PARAMETERS()<1
    quit
 endif
 SET TALK off
 SET ESCAPE on
if FILE('SPR2SCX.ERR')
   erase SPR2SCX.ERR
endif
if FILE('temp.dbf')
   erase temp.dbf
endif
if FILE('temp.fpt')
   erase temp.fpt
endif
if FILE('scrstru.dbf')
   erase scrstru.dbf
endif
if FILE('scrstru.fpt')
   erase scrstru.fpt
endif
if FILE('menustru.dbf')
   erase menustru.dbf
endif
if FILE('menustru.fpt')
   erase menustru.fpt
endif
set default to (mypath)
 CREATE TABLE temp (TEXT 'M', LINE 'N'(7), PROBLEM 'L',  COMMENT 'M', ;
             WORD1 'C'(10), WORD2 'C'(10), WORD3 'C'(10), WORD4 'C'(10), ;
             WORD5 'C'(10), WORD6 'C'(10), WORD7 'C'(10), WORD8 'C'(10), ;
             WORD9 'C'(10), WORD10 'C'(10),RESTTXT 'M',   NOTAPPL 'M', ;
             XPROMPT 'M',   XBEFORE 'M',   XAFTER 'M',    XKEY 'M', ;
             XMARK 'M',     XMESSAGE 'M',  XSKIP 'M',     XCOLOR 'M', ;
             XAT 'M',       XMARGIN 'M',   XRELATIVE 'M', XSHADOW 'M', ;
             CURMENU 'L',  DELREC 'L')
 CREATE TABLE menustru (OBJTYPE 'N' (2), OBJCODE 'N' (2), NAME 'M', ;
             PROMPT 'M',COMMAND 'M',MESSAGE 'M', PROCTYPE 'N' (1), PROCEDURE 'M', ;
             SETUPTYPE 'N' (1),SETUP 'M',CLEANTYPE 'N' (1),CLEANUP 'M', ;
             MARK 'C' (1),KEYNAME 'M' (1),KEYLABEL 'M',SKIPFOR 'M', ;
             NAMECHANGE 'L',NUMITEMS 'N' (2),LEVELNAME 'C' (10), ;
             ITEMNUM 'C' (3),COMMENT 'M',LOCATION 'N' (1),SCHEME 'N' (2))
IF .not. ('3.0'$VERSION() or  '5.0'$VERSION() or '6.0'$VERSION()) && is FoxPro 25 ?
 CREATE TABLE scrstru (PLATFORM  'C' (8),UNIQUEID 'C' (10), TIMESTAMP 'N' (10), ;
              OBJTYPE 'N' (2),OBJCODE 'N' (3),NAME 'M',EXPR 'M',VPOS 'N' (7,3), ;
              HPOS 'N' (7,3),HEIGHT 'N' (7,3),WIDTH 'N' (7,3),STYLE 'N' (2), ;
              PICTURE 'M',ORDER  'M',UNIQUE 'L',COMMENT 'M',ENVIRON 'L', ;
              BOXCHAR 'C' (1),FILLCHAR 'C' (1),TAG 'M',TAG2 'M',PENRED 'N' (5), ;
              PENGREEN 'N' (5),PENBLUE 'N' (5),FILLRED 'N' (5),FILLGREEN  'N' (5), ;
              FILLBLUE 'N' (5),PENSIZE 'N' (5),PENPAT 'N' (5),FILLPAT 'N' (5), ;
              FONTFACE 'M',FONTSTYLE 'N' (3),FONTSIZE 'N' (3),MODE 'N' (3), ;
              RULER 'N' (1),RULERLINES 'N' (1),GRID 'L',GRIDV 'N' (2),GRIDH 'N' (2), ;
              SCHEME 'N' (2),SCHEME2 'N' (2),COLORPAIR  'C' (8),LOTYPE 'N' (1), ;
              RANGELO 'M',HITYPE 'N' (1),RANGEHI 'M',WHENTYPE 'N' (1),WHEN 'M', ;
              VALIDTYPE 'N' (1),VALID 'M',ERRORTYPE 'N' (1),ERROR 'M', ;
              MESSTYPE 'N' (1),MESSAGE 'M',SHOWTYPE 'N' (1),SHOW 'M', ;
              ACTIVTYPE 'N' (1),ACTIVATE 'M',DEACTTYPE 'N' (1),DEACTIVATE 'M', ;
              PROCTYPE 'N' (1),PROCCODE 'M',SETUPTYPE 'N' (1),SETUPCODE 'M',;
              FLOAT 'L',CLOSE 'L',MINIMIZE 'L',BORDER 'N' (1),SHADOW 'L', ;
              CENTER 'L',REFRESH 'L',DISABLED 'L',SCROLLBAR 'L',ADDALIAS 'L', ;
              TAB 'L',INITIALVAL 'M',INITIALNUM 'N' (3),SPACING 'N' (6,3),CURPOS 'L')
else
 CREATE TABLE scrstru ('PLATFORM'  'C' (8),UNIQUEID 'C' (10), TIMESTAMP 'N' (10), ;
              OBJTYPE 'N' (2),OBJCODE 'N' (3),'NAME' 'M','EXPR' 'M',VPOS 'N' (7,3), ;
              HPOS 'N' (7,3),'HEIGHT' 'N' (7,3),'WIDTH' 'N' (7,3),'STYLE' 'N' (2), ;
              'PICTURE' 'M','ORDER'  'M','UNIQUE' 'L',COMMENT 'M','ENVIRON' 'L', ;
              BOXCHAR 'C' (1),FILLCHAR 'C' (1),'TAG' 'M',TAG2 'M',PENRED 'N' (5), ;
              PENGREEN 'N' (5),PENBLUE 'N' (5),FILLRED 'N' (5),FILLGREEN  'N' (5), ;
              FILLBLUE 'N' (5),PENSIZE 'N' (5),PENPAT 'N' (5),FILLPAT 'N' (5), ;
              FONTFACE 'M',FONTSTYLE 'N' (3),FONTSIZE 'N' (3),MODE 'N' (3), ;
              RULER 'N' (1),RULERLINES 'N' (1),GRID 'L',GRIDV 'N' (2),GRIDH 'N' (2), ;
              'SCHEME' 'N' (2),SCHEME2 'N' (2),COLORPAIR  'C' (8),LOTYPE 'N' (1), ;
              RANGELO 'M',HITYPE 'N' (1),RANGEHI 'M',WHENTYPE 'N' (1),'WHEN' 'M', ;
              VALIDTYPE 'N' (1),'VALID' 'M',ERRORTYPE 'N' (1),'ERROR' 'M', ;
              MESSTYPE 'N' (1),'MESSAGE' 'M',SHOWTYPE 'N' (1),'SHOW' 'M', ;
              ACTIVTYPE 'N' (1),'ACTIVATE' 'M',DEACTTYPE 'N' (1),'DEACTIVATE' 'M', ;
              PROCTYPE 'N' (1),PROCCODE 'M',SETUPTYPE 'N' (1),SETUPCODE 'M',;
              'FLOAT' 'L','CLOSE' 'L','MINIMIZE' 'L','BORDER' 'N' (1),'SHADOW' 'L', ;
              'CENTER' 'L','REFRESH' 'L','DISABLED' 'L',SCROLLBAR 'L',ADDALIAS 'L', ;
              'TAB' 'L',INITIALVAL 'M',INITIALNUM 'N' (3),SPACING 'N' (6,3),CURPOS 'L')

endif
 CLOSE DATABASES
 DEFINE WINDOW mpywindow0 FROM 1,INT((SCOL()-71)/2) ;
        TO 10,INT((SCOL()-71)/2)+70 NONE ;
        FLOAT NOCLOSE SHADOW NOMINIMIZE  COLOR SCHEME 7
 ACTIVATE WINDOW mpywindow0
 @1,1  say '                SPR2SCX V1.0'
 @2,1  say '  ļ԰UNFOXALLɵ *.SPR / *.MPRתΪӦ'
 @3,1  say '   SCX/MNXļӶĻ/˵ӻĴ򿪡޸'
 @4,1  say ' FoxPro for DOS/Windows 2.x,  Visual FoxPro 3.0/5.0/6.0'
 @5,1  say '  в˵:'
 @6,1  say '  do spr2scx  with <Tagpath>'
 @7,1  say '  : '

 DEFINE WINDOW mpywindow FROM 14,INT((SCOL()-71)/2) ;
        TO 22,INT((SCOL()-71)/2)+70 TITLE "Message Window" ;
        FLOAT NOCLOSE SHADOW NOMINIMIZE DOUBLE COLOR SCHEME 8
 ACTIVATE WINDOW mpywindow

 IF .not. ('2.5'$VERSION() or '2.6'$VERSION() or '3.0'$VERSION() or  '5.0'$VERSION() or '6.0'$VERSION())
    WAIT window 'this file Need be run under FoxPro for DOS/Windows 2.x,  Visual FoxPro 3.0/5.0/6.0 ' timeout 2
    RETURN
 ENDIF

 PUSH key clear
 PRIVATE setesc, setalk, recovery, cs,mr1,mr2
 SET DEFAULT to (mypath)
 mr1 = ADIR(scx, '*.SPR')
 mr2 = ADIR(mnx, '*.MPR')
 IF mr1+mr2=0
    WAIT window 'Can not find any *.SPR / *.MPR ' timeout 2
    quit
 ENDIF
 msize = IIF(mr2>0, ALEN(mnx, 1), 0)
 ssize = IIF(mr1>0, ALEN(scx, 1), 0)
 DIMENSION all( ssize+msize)
 FOR sp = 1 to ALEN(all)
    IF sp<=ssize
       all( sp) = scx(sp,1)
    ELSE
       all( sp) = mnx(sp-ssize,1)
    ENDIF
 ENDFOR
 ? 'Converting Files ...'
 FOR sp = 1 to ALEN(all)
    inp = 0
    out = 0
    file = LEFT(all(sp), LEN(all(sp))-4)
    path = SYS(5)+SYS(2003)+'\'
    IF '.MPR'$all(sp)
       o1 = 'MPR'
       o2 = 'MNX'
    ELSE
       o1 = 'SPR'
       o2 = 'SCX'
    ENDIF
    inpfile = path+file+'.'+o1
    outfile = path+file+'.'+o2
    DO openinp
    IF '.MPR'$all(sp)
       ? 'Conver Menu Code file: '+all(sp)+ ' to Design file '+path+file+'.'+'MNX  & '+path+file+'.'+'MNT'

       = mpr2mnx()
    ELSE
       ? 'Conver Screen Code file: '+all(sp)+ ' to Design file '+path+file+'.'+'SCX  & '+path+file+'.'+'SCT'
       = spr2scx()
    ENDIF
    = FCLOSE(inp)
    = FCLOSE(out)
 ENDFOR
 recovery = SYS(16)
 = FCLOSE(0)
 POP key
 close all
erase temp.dbf
erase temp.fpt
erase scrstru.dbf
erase scrstru.fpt
erase menustru.dbf
erase menustru.fpt
if FILE('SPR2SCX.ERR')
   erase SPR2SCX.ERR
endif
quit

PROCEDURE rootproc
 PARAMETER modul
 PRIVATE oldsetarr, inpfile, inpexts, outext, outfile, inp, out
 DIMENSION oldsetarr( 13)
 DO newsets
 DO case
    CASE M.modul='SPR2SCX'
       inpexts = 'SPR|PRG|FMT'
       outext = 'SCX'
    CASE M.modul='MPR2MNX'
       inpexts = 'MPR|PRG'
       outext = 'MNX'
    OTHERWISE
       STORE '' to inpexts, outext
 ENDCASE
 STORE '' to inpfile, outfile
 STORE 0 to inp, out
 IF  .not. EMPTY(M.inpexts)
    inpfile = GETFILE(M.inpexts, IIF(_DOS .or. _UNIX, '          ', '')+ ;
              'Select input file')
    IF EMPTY(M.inpfile)
       DO oldsets
       RETURN
    ENDIF
    SET DEFAULT to (LEFT(M.inpfile, RAT('\', M.inpfile)))
    IF  .not. EMPTY(M.outext)
       DO tstoutfile
       IF EMPTY(M.outfile)
          DO oldsets
          RETURN
       ENDIF
    ENDIF
    IF M.modul<>'FXP2PRG'
       DO openinp
       IF M.inp<=0
          DO oldsets
          RETURN
       ENDIF
    ENDIF
 ENDIF
 DO (M.modul)
 IF M.inp>0
    DO closeinp
 ENDIF
 DO oldsets
 RETURN

PROCEDURE newsets
 PRIVATE tmp
 PUSH key clear
 IF SET('TALK')='ON'
    SET TALK off
    oldsetarr( 1) = 'ON'
 ELSE
    oldsetarr( 1) = 'OFF'
 ENDIF
 oldsetarr( 2) = SET('ESCA')
 SET ESCAPE on
 oldsetarr( 3) = SET('TRBE')
 oldsetarr( 4) = SET('COMP')
 oldsetarr( 5) = SET('EXAC')
 oldsetarr( 6) = SET('ALTE')
 oldsetarr( 7) = SET('DOHI')
 oldsetarr( 8) = SET('DEBU')
 oldsetarr( 9) = SET('HELP')
 oldsetarr( 10) = SET('HELP', 1)
 oldsetarr( 11) = SET('PROC')
 oldsetarr( 12) = SET('FULL')
 oldsetarr( 13) = ON('ERRO')
 SET COMPATIBLE to foxplus
 SET EXACT off
 SET ALTERNATE off
 SET DOHISTORY off
 SET PROCEDURE to
 SET FULLPATH on
 RETURN
 RETURN

PROCEDURE oldsets
 PRIVATE tmp
 IF EMPTY(oldsetarr(13))
    ON error
 ELSE
    ON ERROR &oldsetarr[13]
 ENDIF
 IF oldsetarr(3)='ON'
    SET TRBETWEEN on
 ENDIF
 IF oldsetarr(4)='ON'
    SET COMPATIBLE to db4
 ENDIF
 IF oldsetarr(5)='ON'
    SET EXACT on
 ENDIF
 IF oldsetarr(6)='ON'
    SET ALTERNATE on
 ENDIF
 IF oldsetarr(8)='ON'
    SET DEBUG on
 ENDIF
 IF oldsetarr(9)='OFF'
    SET HELP off
 ENDIF
 IF  .not. EMPTY(oldsetarr(10))
    SET HELP to (oldsetarr(10))
 ENDIF
 IF  .not. EMPTY(oldsetarr(11))
    SET PROCEDURE to (oldsetarr(11))
 ENDIF
 IF oldsetarr(12)='OFF'
    SET FULLPATH off
 ENDIF
 IF oldsetarr(7)='ON'
    SET DOHISTORY on
 ENDIF
 IF oldsetarr(1)='ON'
    SET TALK on
 ENDIF
 IF oldsetarr(2)='ON'
    SET ESCAPE on
 ENDIF
 POP key
 RETURN

FUNCTION antipath_
 PRIVATE startfile_
 startfile_ = AT(' ', SYS(16), 2)
 RETURN SUBSTR(SYS(16), M.startfile_+1, RAT('\', SYS(16))-M.startfile_)

PROCEDURE uninstall
 RELEASE popup extended recovery
 RELEASE pad recovery of _MSYSMENU

PROCEDURE spr2scx
 PRIVATE ftmp, ftmpname, ftmp2, ftmpname2
 PRIVATE tmp, selarea, outvers, oldsafe, scrnalias, line, linecnt, linpos
 PRIVATE docase, bracketed, psblbracke, bracklevel, codepart, paramcmd,  ;
         endofstart, cleanuppos, defiwind
 PRIVATE afterread, cmntblock, lastcmnt, section2, noread, noreadplai,  ;
         wnameclaus
 PRIVATE linarray, linarrayle, nkoords, koords, koordtype, getarray, getarrayle
 DIMENSION linarray( 1), koords( 4), getarray( 1)
 linarrayle = 1
 getarrayle = 0
 STORE 0 to ftmp, ftmp2, selarea, linecnt, docase, nkoords, koords,  ;
       endofstart, cleanuppos
 STORE 1 to linpos, bracklevel
 STORE '' to tmp, line, ftmpname, ftmpname2, linarray( 1), paramcmd,  ;
       codepart, koordtype, cmntblock, wnameclaus
 STORE .F. to bracketed, defiwind, afterread, lastcmnt, section2, noread,  ;
       noreadplai
 STORE .T. to psblbracke
 M.override = .F.
 PRIVATE buffer, bufptr, eofinp
 buffer = ''
 bufptr = 0
 eofinp = .F.
 IF  .not. creatmp()
    DO gnerr_ with 'Cannot create temporary file'+CHR(13)+M.ftmpname
    RETURN
 ENDIF
 IF  .not. creatmp2()
    DO gnerr_ with 'Cannot create temporary file'+CHR(13)+M.ftmpname2
    DO deletmp
    RETURN
 ENDIF
 IF SELECT(1)<=0
    DO gnerr_ with 'No free work area to open'+CHR(13)+M.outfile
    DO deletmp
    DO deletmp2
    RETURN
 ENDIF
 IF isfree(M.outfile,5000)
    outvers = '25'
    oldsafe = SET('SAFE')
    SET SAFETY off
    COPY file ('SCRSTRU.DBF') to (M.outfile)
    COPY file ('SCRSTRU.FPT') to (LEFT(M.outfile,  ;
         LEN(M.outfile)-3)+'SCT')
    IF M.oldsafe='ON'
       SET SAFETY on
    ENDIF
 ELSE
    DO gnerr_ with 'Insufficient disk space for'+CHR(13)+M.outfile
    DO deletmp
    DO deletmp2
    RETURN
 ENDIF
 selarea = SELECT(0)
 SELECT 0
 scrnalias = SYS(2015)
 USE (M.outfile) alias (M.scrnalias)
 IF M.outvers<>'20'
    INSERT into (M.scrnalias) (uniqueid, objtype, objcode, height, width)  ;
           value (SYS(2015), 1, 63, 25, 80)
 ELSE
    INSERT into (M.scrnalias) (comment, objtype, objcode, height, width)  ;
           value (SYS(2015), 1, 10, 25, 80)
 ENDIF
 GOTO 1
 DO puttmpline with '#SECTION 1'+CHR(13)+CHR(10)
 DO getcmd
 DO while  .not. M.eofinp
    DO case
       CASE testword1('DO','CASE')
          DO puttmpcmnt
          docase = M.docase+1
          IF M.psblbracke
             psblbracke = .F.
             tmp = M.line
             DO getcmd
             DO case
                CASE testword1('CASE','_dos')
                   bracketed = .T.
                   bracklevel = 2
                   codepart = 'DOS'
                CASE testword1('CASE','_windows')
                   bracketed = .T.
                   bracklevel = 2
                   codepart = 'WINDOWS'
                CASE testword1('CASE','_mac')
                   bracketed = .T.
                   bracklevel = 2
                   codepart = 'MAC'
                CASE testword1('CASE','_unix')
                   bracketed = .T.
                   bracklevel = 2
                   codepart = 'UNIX'
                OTHERWISE
                   DO puttmpline with M.tmp
                   LOOP
             ENDCASE
             IF M.outvers<>'20'
                GOTO 1
                REPLACE platform with M.codepart
             ENDIF
             DO getcmd
             LOOP
          ENDIF
       CASE testword1('PARAMETERS')
          DO puttmpcmnt
          paramcmd = M.line
       CASE testword1('DEFINE','WINDOW')
          DO puttmpcmnt
          psblbracke = .F.
          IF  .not. M.defiwind
             DO defiwind with .T.
          ENDIF
       CASE testword1('MODIFY','WINDOW','SCREEN')
          DO puttmpcmnt
          psblbracke = .F.
          IF  .not. M.defiwind
             DO defiwind with .F.
          ENDIF
       CASE testword1('MOVE','WINDOW')
          DO puttmpcmnt
          psblbracke = .F.
          IF M.defiwind .and. 'CENTER'$M.line
             GOTO 1
             REPLACE center with .T.
          ENDIF
       CASE testchars('@')
          DO puttmpcmnt
          psblbracke = .F.
          linpos = M.linpos+1
          IF testkoords()
             IF inword('SAY','GET','EDIT','BOX','TO')>0
                EXIT
             ENDIF
          ENDIF
       CASE testword1('READ') .or. testword1('PROCEDURE') .or.  ;
            testword1('FUNCTION')
          psblbracke = .F.
          EXIT
       CASE testword1('ENDCASE')
          DO puttmpcmnt
          IF M.docase>0
             docase = M.docase-1
             IF M.bracketed .and. M.docase=0
                bracklevel = 1
             ENDIF
          ENDIF
       CASE testchars('*')
          IF M.lastcmnt
             cmntblock = M.cmntblock+CHR(13)+CHR(10)+M.line
          ELSE
             cmntblock = M.line
             lastcmnt = .T.
          ENDIF
          DO getcmd
          LOOP
       OTHERWISE
          IF M.defiwind .and.  .not. M.section2 .and.  .not. M.override
             M.override = .T.
          ELSE
             IF M.defiwind .and.  .not. M.section2
                DO puttmpline with CHR(13)+CHR(10)+'#SECTION 2   '+ ;
                   CHR(38)+CHR(38)+ ;
                   'REMOVE CODE UP TO AND INCLUDING THIS LINE  ?? _______ ?? (Generated Code?)'+ ;
                   CHR(13)+CHR(10)
                section2 = .T.
             ENDIF
          ENDIF
          DO puttmpcmnt
          IF M.psblbracke .and.  .not. (testchars('#') .or. testchars('&'+CHR(38)) .or. testword1('NOTE') .or. testchars('*') .or. EMPTY(M.line))
             psblbracke = .F.
          ENDIF
    ENDCASE
    DO puttmpcmd
    DO getcmd
 ENDDO
 DO puttmpline with CHR(13)+CHR(10)+ ;
    '* ******** End of Startup code ********'+CHR(13)+CHR(10)
 DO puttmpline with '*unknown  commands:'+CHR(13)+CHR(10)
 endofstart = tmpseekpos()
 cleanuppos = M.endofstart
 DO while  .not. M.eofinp
    DO case
       CASE testchars('@')
          DO puttmpcmnt
          IF  .not. M.afterread .and. sayget()
             cleanuppos = tmpseekpos()
          ELSE
             DO puttmpcmd
          ENDIF
       CASE testword1('READ')
          DO puttmpcmnt
          IF  .not. M.afterread
             DO readcmd
             afterread = .T.
             cleanuppos = tmpseekpos()
          ENDIF
       CASE testword1('FUNCTION') .or. testword1('PROCEDURE')
          EXIT
       CASE testword1('DO','CASE')
          DO puttmpcmnt
          docase = M.docase+1
          DO puttmpcmd
       CASE testword1('CASE')
          DO puttmpcmnt
          IF M.docase=1 .and. M.bracketed
             ?? CHR(7)
             WAIT window timeout 2 getnextwor()+' part ignored'
             tmp = .F.
             DO while M.docase>0
                DO getcmd
                DO case
                   CASE testword1('DO','CASE')
                      lastcmnt = .F.
                      docase = M.docase+1
                   CASE testword1('ENDCASE')
                      lastcmnt = .F.
                      docase = M.docase-1
                      IF M.bracketed .and. M.docase=0
                         bracklevel = 1
                      ENDIF
                   CASE testword1('FUNCTION') .or. testword1('PROCEDURE')
                      tmp = .T.
                      EXIT
                   CASE testchars('*')
                      IF M.lastcmnt
                         cmntblock = M.cmntblock+CHR(13)+CHR(10)+M.line
                      ELSE
                         cmntblock = M.line
                         lastcmnt = .T.
                      ENDIF
                   OTHERWISE
                      lastcmnt = .F.
                ENDCASE
             ENDDO
             IF M.tmp
                EXIT
             ENDIF
          ELSE
             DO puttmpcmd
          ENDIF
       CASE testword1('ENDCASE')
          DO puttmpcmnt
          IF M.docase>0
             docase = M.docase-1
             IF M.bracketed .and. M.docase=0
                bracklevel = 1
             ENDIF
          ENDIF
          IF  .not. M.bracketed .or. M.docase>0
             DO puttmpcmd
          ENDIF
       CASE testchars('*')
          IF M.lastcmnt
             cmntblock = M.cmntblock+CHR(13)+CHR(10)+M.line
          ELSE
             cmntblock = M.line
             lastcmnt = .T.
          ENDIF
       OTHERWISE
          DO puttmpcmnt
          DO puttmpcmd
    ENDCASE
    DO getcmd
 ENDDO
 tmp = ''
 IF  .not. EMPTY(M.wnameclaus)
    tmp = M.tmp+CHR(13)+CHR(10)+'#WNAME '+M.wnameclaus
 ENDIF
 IF  .not. M.afterread
    tmp = M.tmp+CHR(13)+CHR(10)+'#NOREAD'
    IF  .not. M.defiwind
       tmp = M.tmp+' PLAIN'
    ENDIF
 ENDIF
 IF M.outvers<>'20'
    GOTO 1
    IF EMPTY(platform)
       platform = IIF(EMPTY(M.codepart), M.koordtype, M.codepart)
       REPLACE platform with M.platform
    ENDIF
 ENDIF
 IF  .not. EMPTY(M.tmp)
    GOTO 1
    REPLACE setupcode with M.tmp+CHR(13)+CHR(10)
 ENDIF
 DO while  .not. M.eofinp
    DO case
       CASE testword1('FUNCTION') .or. testword1('PROCEDURE')
          IF procfun()
             LOOP
          ELSE
             DO puttmpcmnt
             DO puttmpcmd
          ENDIF
       CASE testchars('*')
          IF M.lastcmnt
             cmntblock = M.cmntblock+CHR(13)+CHR(10)+M.line
          ELSE
             cmntblock = M.line
             lastcmnt = .T.
          ENDIF
       OTHERWISE
          DO puttmpcmnt
          DO puttmpcmd
    ENDCASE
    DO getcmd
 ENDDO
 DO puttmpcmnt
 DO setupclean
 DO restofproc
 IF M.outvers='20'
    REPLACE comment with ('') for  .not. EMPTY(comment) .and.  ;
            issys2015(comment)
 ENDIF
 USE
 SELECT (M.selarea)
 WAIT window nowait 'Screen table created'
 RETURN

FUNCTION testchars
 PARAMETER chars
 linpos = 1
 DO while M.linpos<=LEN(M.line) .and. SUBSTR(M.line, M.linpos, 1)$CHR(9)+' '
    linpos = M.linpos+1
 ENDDO
 IF M.linpos+LEN(M.chars)>LEN(M.line)+1
    RETURN .F.
 ENDIF
 RETURN M.chars==SUBSTR(M.line, M.linpos, LEN(M.chars))

FUNCTION testkoords
 PRIVATE valid, i
 nkoords = 0
 koordtype = ''
 IF skipbl_eol()
    RETURN .F.
 ENDIF
 valid = .T.
 FOR i = 1 to 4
    koords( M.i) = getknum(M.valid)
    IF  .not. M.valid
       RETURN .F.
    ENDIF
    nkoords = M.nkoords+1
    IF skipbl_eol()
       RETURN .F.
    ENDIF
    IF SUBSTR(M.line, M.linpos, 1)=','
       linpos = M.linpos+1
       IF SUBSTR(M.line, M.linpos, 1)==' '
          linpos = M.linpos+1
       ENDIF
       LOOP
    ENDIF
    RETURN INLIST(M.i, 2, 4)
 ENDFOR
 RETURN .F.

FUNCTION skipbl_eol
 DO while M.linpos<=LEN(M.line) .and. SUBSTR(M.line, M.linpos, 1)$CHR(9)+' '
    linpos = M.linpos+1
 ENDDO
 RETURN M.linpos>LEN(M.line)

FUNCTION testnextwo
 PARAMETER w
 PRIVATE word
 word = getnextwor()
 IF EMPTY(M.word)
    RETURN .F.
 ENDIF
 IF ISUPPER(M.w)
    IF M.w<>UPPER(M.word)
       RETURN .F.
    ENDIF
 ELSE
    IF  .not. (M.w==LOWER(M.word))
       RETURN .F.
    ENDIF
 ENDIF
 RETURN .T.

FUNCTION testword1
 PARAMETER w1, w2, w3, w4
 PRIVATE word, npars
 npars = PARAMETERS()
 word = getword1()
 IF EMPTY(M.word)
    RETURN .F.
 ENDIF
 IF ISUPPER(M.w1)
    IF M.w1<>UPPER(M.word)
       RETURN .F.
    ENDIF
    IF LEN(M.word)<4 .and. LEN(M.w1)>LEN(M.word)
       RETURN .F.
    ENDIF
 ELSE
    IF  .not. (M.w1==LOWER(M.word))
       RETURN .F.
    ENDIF
 ENDIF
 IF M.npars>1
    word = getnextwor()
    IF EMPTY(M.word)
       RETURN .F.
    ENDIF
    IF ISUPPER(M.w2)
       IF M.w2<>UPPER(M.word)
          RETURN .F.
       ENDIF
       IF LEN(M.word)<4 .and. LEN(M.w2)>LEN(M.word)
          RETURN .F.
       ENDIF
    ELSE
       IF  .not. (M.w2==LOWER(M.word))
          RETURN .F.
       ENDIF
    ENDIF
 ENDIF
 IF M.npars>2
    word = getnextwor()
    IF EMPTY(M.word)
       RETURN .F.
    ENDIF
    IF ISUPPER(M.w3)
       IF M.w3<>UPPER(M.word)
          RETURN .F.
       ENDIF
       IF LEN(M.word)<4 .and. LEN(M.w3)>LEN(M.word)
          RETURN .F.
       ENDIF
    ELSE
       IF  .not. (M.w3==LOWER(M.word))
          RETURN .F.
       ENDIF
    ENDIF
 ENDIF
 RETURN .T.

FUNCTION getword1
 linpos = 1
 RETURN getnextwor()

FUNCTION getnextwor
 PRIVATE i, word, znak
 IF skipbl_eol()
    RETURN ''
 ENDIF
 znak = SUBSTR(M.line, M.linpos, 1)
 IF ISDIGIT(M.znak)
    RETURN ''
 ENDIF
 word = ''
 DO while M.linpos<=LEN(M.line) .and. (ISALPHA(M.znak) .or. ISDIGIT(M.znak) .or. M.znak$'_&' .or. ASC(M.znak)>127)
    word = M.word+M.znak
    linpos = M.linpos+1
    IF M.linpos<=LEN(M.line)
       znak = SUBSTR(M.line, M.linpos, 1)
    ENDIF
 ENDDO
 IF '&'+CHR(38)$M.word
    word = LEFT(M.word, AT('&'+CHR(38), M.word)-1)
    linpos = LEN(M.line)+1
 ENDIF
 RETURN M.word

FUNCTION getx
 PRIVATE i, expr, znak, word, lastop, lastword, closchar, parent, tmp
 IF skipbl_eol()
    RETURN ''
 ENDIF
 STORE '' to word, expr
 lastop = .T.
 lastword = .F.
 parent = 0
 DO while M.linpos<=LEN(M.line)
    znak = SUBSTR(M.line, M.linpos, 1)
    DO case
       CASE M.znak$["'{] .or. (M.znak='[' .and. M.lastop)
          DO case
             CASE M.znak='{'
                closchar = '}'
             CASE M.znak='['
                closchar = ']'
             OTHERWISE
                closchar = M.znak
          ENDCASE
          expr = M.expr+M.znak
          linpos = M.linpos+1
          DO while M.linpos<=LEN(M.line) .and. SUBSTR(M.line, M.linpos,  ;
             1)<>M.closchar
             expr = M.expr+SUBSTR(M.line, M.linpos, 1)
             linpos = M.linpos+1
          ENDDO
          lastop = .F.
          lastword = .F.
          lastspace = .F.
          znak = M.closchar
       CASE M.znak$'(['
          parent = M.parent+1
          lastop = .F.
          lastword = .F.
          lastspace = .F.
       CASE M.znak$')]'
          IF M.parent>0
             parent = M.parent-1
          ENDIF
          lastop = .F.
          lastword = .F.
          lastspace = .F.
       CASE M.znak$'+-*/%^=!<>#$.'
          lastop = M.znak<>'.'
          lastword = .F.
          lastspace = .F.
       CASE ISDIGIT(M.znak)
          expr = M.expr+getnum()
          lastop = .F.
          lastword = .F.
          lastspace = .F.
          LOOP
       CASE ISALPHA(M.znak) .or. M.znak$'_&' .or. ASC(M.znak)>127
          IF M.lastword
             EXIT
          ENDIF
          word = getnextwor()
          expr = M.expr+M.word
          lastop = UPPER(M.word)=='AND' .or. UPPER(M.word)=='OR' .or.  ;
                   UPPER(M.word)=='NOT'
          lastword =  .not. M.lastop
          lastspace = .F.
          IF M.lastop .and. SUBSTR(M.line, M.linpos, 1)='.'
             znak = '.'
          ELSE
             LOOP
          ENDIF
       OTHERWISE
          IF M.parent=0 .and. (( .not. M.lastop .and. M.znak$' '+CHR(9))  ;
             .or. M.znak=',')
             IF M.znak<>','
                lastspace = .T.
                IF skipbl_eol()
                   EXIT
                ENDIF
                expr = M.expr+' '
                znak = SUBSTR(M.line, M.linpos, 1)
                IF M.znak$'+-*/%^=!<>#$.' .or. (M.lastword .and. M.znak$'[(')
                   LOOP
                ENDIF
                tmp = M.linpos
                word = getnextwor()
                linpos = M.tmp
                IF UPPER(M.word)=='AND' .or. UPPER(M.word)=='OR'
                   LOOP
                ENDIF
             ENDIF
             EXIT
          ENDIF
          IF M.znak$CHR(9)+' '
             IF M.lastspace
                znak = ''
             ELSE
                znak = ' '
                lastspace = .T.
             ENDIF
          ENDIF
    ENDCASE
    expr = M.expr+M.znak
    linpos = M.linpos+1
 ENDDO
 RETURN ALLTRIM(M.expr)

PROCEDURE getcmd
 linpos = 1
 DIMENSION linarray( 1)
 line = adjindent(getline())
 linarray( 1) = M.line
 linarrayle = 1
 DO while continued()
    linarrayle = M.linarrayle+1
    DIMENSION linarray( M.linarrayle)
    linarray( M.linarrayle) = adjindent(getline())
    line = M.line+linarray(M.linarrayle)
 ENDDO

FUNCTION getline
 PRIVATE char, text
 text = ''
 char = getchar()
 DO while M.char<>CHR(13) .and. LEN(M.char)>0
    IF M.char=CHR(10)
       char = getchar()
       LOOP
    ENDIF
    text = M.text+M.char
    char = getchar()
 ENDDO
 IF LEN(M.text)>0 .or. LEN(M.char)>0
    linecnt = M.linecnt+1
    WAIT window nowait 'converting: '+ALLTRIM(STR(M.linecnt))+' of Total DATA'
 ELSE
    eofinp = .T.
 ENDIF
 RETURN M.text

FUNCTION adjindent
 PARAMETER text
 IF M.bracklevel<=1
    RETURN M.text
 ENDIF
 IF LEFT(M.text, M.bracklevel-1)==REPLICATE(CHR(9), M.bracklevel-1)
    RETURN SUBSTR(M.text, M.bracklevel)
 ENDIF
 RETURN M.text

FUNCTION getchar
 IF M.bufptr>=LEN(M.buffer)
    buffer = FREAD(M.inp, 1024)
    bufptr = 0
    IF LEN(M.buffer)=0
       RETURN ''
    ENDIF
 ENDIF
 bufptr = M.bufptr+1
 RETURN SUBSTR(M.buffer, M.bufptr, 1)

FUNCTION continued
 PRIVATE i
 FOR i = LEN(M.line) to 1 step -1
    IF SUBSTR(M.line, M.i, 1)$CHR(9)+' '
       LOOP
    ENDIF
    IF SUBSTR(M.line, M.i, 1)=';'
       line = LEFT(M.line, M.i-1)
       RETURN .T.
    ELSE
       RETURN .F.
    ENDIF
 ENDFOR
 RETURN .F.

PROCEDURE puttmpcmd
 PRIVATE i
 FOR i = 1 to M.linarrayle
    DO puttmpline with linarray(M.i)
 ENDFOR

PROCEDURE puttmpcmnt
 IF M.lastcmnt
    DO puttmpline with M.cmntblock
    lastcmnt = .F.
 ENDIF

PROCEDURE puttmpline
 PARAMETER text
 = FWRITE(M.ftmp, M.text+CHR(13)+CHR(10))
 RETURN

FUNCTION sayget
 PRIVATE tmp, expr, word, name, vpos, hpos, height, width, style, picture,  ;
         function, boxchar, fillchar
 PRIVATE tag, tag2, penred, pengreen, penblue, fillred, fillgreen,  ;
         fillblue, pensize
 PRIVATE penpat, fillpat, fontface, fontstyle, fontsize, mode, ruler,  ;
         rulerlines, grid
 PRIVATE gridv, gridh, scheme, scheme2, colorpair, lotype, rangelo,  ;
         hitype, rengehi
 PRIVATE whentype, when, validtype, valid, errortype, error, messtype, message
 PRIVATE border, center, refresh, disabled, scrollbar, addalias, tab,  ;
         initialval
 PRIVATE initialnum, spacing, platform, objtype, objnum, objcode
 PRIVATE function, size1, size2, size3, fontsizech, stylech, default,  ;
         from, popup, spiner1, spiner2, spiner3, noedit
 PRIVATE bitmap, isometric, stretch, cmd, color, uniqueid, insexpr,  ;
         pattern, pen1, pen2, double, panel
 STORE '' to name, expr, picture, function, tag, tag2, fontface,  ;
       colorpair, rangelo, rangehi
 STORE '' to when, valid, error, message, initialval, boxchar, fillchar,  ;
       platform
 STORE 0 to vpos, hpos, height, width, style, pensize, penpat, fillpat,  ;
       fontstyle
 STORE 0 to fontsize, mode, ruler, rulerlines, gridv, gridh, scheme,  ;
       scheme2, lotype
 STORE 0 to hitype, whentype, validtype, errortype, messtype, showtype, border
 STORE 0 to initialnum, spacing, objtype, objnum, objcode
 STORE -1 to penred, pengreen, penblue, fillred, fillgreen, fillblue
 STORE .F. to grid, center, refresh, disabled, scrollbar, addalias, tab
 STORE '' to function, size1, size2, size3, fontsizech, stylech, default,  ;
       from, popup
 STORE '' to spiner1, spiner2, spiner3, cmd, color, uniqueid, insexpr,  ;
       pattern, pen1, pen2
 STORE .F. to noedit, bitmap, isometric, stretch, double, panel
 linpos = M.linpos+1
 IF testkoords()
    tmp = inword('SAY','GET','EDIT','TO','FILL','BOX')
    DO case
       CASE M.tmp=1
          cmd = 'SAY'
       CASE M.tmp=2
          cmd = 'GET'
       CASE M.tmp=3
          cmd = 'EDIT'
       CASE M.tmp=4
          cmd = 'TO'
       CASE M.tmp=5
          cmd = 'FILL'
       CASE M.tmp=6
          cmd = 'BOX'
       OTHERWISE
          cmd = ''
    ENDCASE
    IF BETWEEN(M.tmp, 1, 3) .and. M.nkoords=2
       expr = getx()
       DO while M.linpos<LEN(M.line)
          word = UPPER(getnextwor())
          DO case
             CASE EMPTY(word)
                WAIT window timeout 0.1 'Skipping ....'
                M.linpos = M.linpos+1
             CASE 'FUNCTION'=M.word
                function = getx()
             CASE 'PICTURE'=M.word
                picture = getx()
             CASE 'SIZE'=M.word
                size1 = getx()
                IF SUBSTR(M.line, M.linpos, 1)=','
                   linpos = M.linpos+1
                   size2 = getx()
                   IF SUBSTR(M.line, M.linpos, 1)=','
                      linpos = M.linpos+1
                      size3 = getx()
                   ENDIF
                ENDIF
             CASE 'FONT'=M.word
                fontface = getx()
                IF SUBSTR(M.line, M.linpos, 1)=','
                   linpos = M.linpos+1
                   fontsizech = getx()
                ENDIF
             CASE 'STYLE'=M.word
                stylech = UPPER(getx())
             CASE 'COLOR'=M.word
                DO getcolor
             CASE 'BITMAP'=M.word
                bitmap = .T.
             CASE 'CENTER'=M.word
                center = .T.
             CASE 'ISOMETRIC'=M.word
                isometric = .T.
             CASE 'STRETCH'=M.word
                stretch = .T.
             CASE 'VERB'=M.word
                RETURN .F.
             CASE 'DEFAULT'=M.word
                default = getx()
             CASE 'ENABLE'=M.word
                disabled = .F.
             CASE 'DISABLE'=M.word
                disabled = .T.
             CASE 'MESSAGE'=M.word
                message = getx()
             CASE 'OPEN'=M.word
             CASE 'WINDOW'=M.word
                = getx()
             CASE 'RANGE'=M.word
                rangelo = getx()
                IF SUBSTR(M.line, M.linpos, 1)=','
                   linpos = M.linpos+1
                   rangehi = getx()
                ENDIF
             CASE 'VALID'=M.word
                valid = getx()
             CASE 'ERROR'=M.word
                error = getx()
             CASE 'WHEN'=M.word
                when = getx()
             CASE 'FROM'=M.word
                from = getx()
             CASE 'POPUP'=M.word
                popup = getx()
             CASE 'SPINNER'=M.word
                spiner1 = getx()
                IF SUBSTR(M.line, M.linpos, 1)=','
                   linpos = M.linpos+1
                   spiner2 = getx()
                   IF SUBSTR(M.line, M.linpos, 1)=','
                      linpos = M.linpos+1
                      spiner3 = getx()
                   ENDIF
                ENDIF
             CASE 'NOEDIT'=M.word
                noedit = .T.
             CASE 'NOMODIFY'=M.word
                noedit = .T.
             CASE 'TAB'=M.word
                tab = .T.
             CASE 'SCROLL'=M.word
                scrollbar = .T.
             OTHERWISE
                WAIT window nowait timeout 0.5 M.word+' is not processed ...'
          ENDCASE
       ENDDO
       IF M.cmd=='SAY'
          IF M.bitmap
             IF M.outvers='20'
                RETURN .F.
             ENDIF
             objtype = 17
             picture = getlfname(M.expr)
             DO case
                CASE M.isometric
                   border = 1
                CASE M.stretch
                   border = 2
                OTHERWISE
                   border = 0
             ENDCASE
             IF 'T'$M.stylech
                mode = 1
             ELSE
                mode = 0
             ENDIF
             style = 0
             height = VAL(M.size1)
             width = VAL(M.size2)
             IF M.height=0 .or. M.width=0
                RETURN .F.
             ENDIF
             platform = IIF(EMPTY(M.codepart), M.koordtype, M.codepart)
             IF M.picture=='"@^"'
                M.picture = '"@^ "'
             ENDIF
             INSERT into (M.scrnalias) (platform, uniqueid, objtype, vpos,  ;
                    hpos, height, width, style, picture, mode, border,  ;
                    center) value (M.platform, SYS(2015), 17, koords(1),  ;
                    koords(2), M.height, M.width, M.style, M.picture,  ;
                    M.mode, M.border, M.center)
             RETURN .T.
          ENDIF
          IF  .not. M.bitmap .and. iswinkoord(M.size1) .and. (M.isometric  ;
              .or. M.stretch .or. M.center .or. (M.stylech=='""' .and.  ;
              EMPTY(M.picture) .and. EMPTY(M.color) .and.  ;
              EMPTY(M.fontface) .and.  .not. EMPTY(M.size1) .and.  .not.  ;
              EMPTY(M.size2) .and. EMPTY(M.function) .and. EMPTY(M.size3)  ;
              .and. (ISALPHA(M.expr) .or. LEFT(M.expr, 1)='_')))
             objtype = 17
             IF M.outvers='20'
                RETURN .F.
             ENDIF
             DO case
                CASE M.isometric
                   border = 1
                CASE M.stretch
                   border = 2
                OTHERWISE
                   border = 0
             ENDCASE
             style = 1
             mode = 0
             height = VAL(M.size1)
             width = VAL(M.size2)
             IF M.height=0 .or. M.width=0
                RETURN .F.
             ENDIF
             platform = IIF(EMPTY(M.codepart), M.koordtype, M.codepart)
             INSERT into (M.scrnalias) (platform, uniqueid, objtype, name,  ;
                    vpos, hpos, height, width, style, mode, border,  ;
                    center) value (M.platform, SYS(2015), 17, M.expr,  ;
                    koords(1), koords(2), M.height, M.width, M.style,  ;
                    M.mode, M.border, M.center)
             RETURN .T.
          ENDIF
          DO spojpicfun
          IF (EMPTY(M.size3) .and.  .not. EMPTY(M.size2)) .or.  ;
             issayexpr(M.expr)
             objtype = 15
             fillchar = TYPE(M.expr)
             IF M.fillchar='U'
                fillchar = ''
             ENDIF
             STORE 1 to lotype, hitype, whentype, validtype, errortype,  ;
                   messtype
          ELSE
             objtype = 5
             expr = transaytex(M.expr)
          ENDIF
          objcode = 0
          mode = IIF('T'$M.stylech, 1, 0)
          fontstyle = 0+IIF('B'$M.stylech, 1, 0)+IIF('I'$M.stylech, 2, 0)
          fontsize = IIF(EMPTY(M.fontsizech), 8, VAL(M.fontsizech))
          fontface = IIF(EMPTY(gettext(M.fontface)), M.fontface,  ;
                     SUBSTR(M.fontface, 2, LEN(M.fontface)-2))
          height = IIF(EMPTY(M.size1), 1, VAL(M.size1))
          width = IIF(EMPTY(M.size2), LEN(M.expr)-2, VAL(M.size2))
          spacing = IIF(EMPTY(M.size3), 0, VAL(M.size3))
          platform = IIF(EMPTY(M.codepart), M.koordtype, M.codepart)
          IF M.picture=='"@^"'
             M.picture = '"@^ "'
          ENDIF
          IF INLIST(M.platform, 'DOS', 'UNIX')
             IF M.outvers='20'
                INSERT into (M.scrnalias) (objtype, objcode, expr, vpos,  ;
                       hpos, height, width, picture, fillchar, lotype,  ;
                       hitype, whentype, validtype, errortype, messtype,  ;
                       scheme, colorpair) value (M.objtype, M.objcode,  ;
                       M.expr, koords(1), koords(2), M.height, M.width,  ;
                       M.picture, M.fillchar, M.lotype, M.hitype,  ;
                       M.whentype, M.validtype, M.errortype, M.messtype,  ;
                       M.scheme, M.colorpair)
             ELSE
                INSERT into (M.scrnalias) (platform, uniqueid, objtype,  ;
                       objcode, expr, vpos, hpos, height, width, picture,  ;
                       fillchar, mode, lotype, hitype, whentype,  ;
                       validtype, errortype, messtype, scheme, colorpair)  ;
                       value (M.platform, SYS(2015), M.objtype, M.objcode,  ;
                       M.expr, koords(1), koords(2), M.height, M.width,  ;
                       M.picture, M.fillchar, M.mode, M.lotype, M.hitype,  ;
                       M.whentype, M.validtype, M.errortype, M.messtype,  ;
                       M.scheme, M.colorpair)
             ENDIF
          ELSE
             IF M.outvers='20'
                RETURN .F.
             ENDIF
             INSERT into (M.scrnalias) (platform, uniqueid, objtype,  ;
                    objcode, expr, vpos, hpos, height, width, picture,  ;
                    fillchar, mode, lotype, hitype, whentype, validtype,  ;
                    errortype, messtype, fillred, fillgreen, fillblue,  ;
                    penred, pengreen, penblue, fontface, fontstyle,  ;
                    fontsize, spacing) value (M.platform, SYS(2015),  ;
                    M.objtype, M.objcode, M.expr, koords(1), koords(2),  ;
                    M.height, M.width, M.picture, M.fillchar, M.mode,  ;
                    M.lotype, M.hitype, M.whentype, M.validtype,  ;
                    M.errortype, M.messtype, M.fillred, M.fillgreen,  ;
                    M.fillblue, M.penred, M.pengreen, M.penblue,  ;
                    M.fontface, M.fontstyle, M.fontsize, M.spacing)
          ENDIF
          RETURN .T.
       ENDIF
       IF M.cmd=='GET' .or. M.cmd='EDIT'
          STORE 1 to lotype, hitype, whentype, validtype, errortype, messtype
          name = M.expr
          platform = IIF(EMPTY(M.codepart), M.koordtype, M.codepart)
          IF M.outvers='20' .and. INLIST(M.platform, 'WINDOWS', 'MAC')
             RETURN .F.
          ENDIF
          uniqueid = UPPER(SYS(2015))
          DO testfragme with M.message, M.messtype, 'MESSAGE'
          DO testfragme with M.valid, M.validtype, 'VALID'
          DO testfragme with M.error, M.errortype, 'ERROR'
          DO testfragme with M.when, M.whentype, 'WHEN'
          DO testfragme with M.rangelo, M.lotype, 'RANGELO'
          DO testfragme with M.rangehi, M.hitype, 'RANGEHI'
          fontstyle = 0+IIF('B'$M.stylech, 1, 0)+IIF('I'$M.stylech, 2, 0)
          fontsize = IIF(EMPTY(M.fontsizech), 8, VAL(M.fontsizech))
          fontface = IIF(EMPTY(gettext(M.fontface)), M.fontface,  ;
                     SUBSTR(M.fontface, 2, LEN(M.fontface)-2))
          height = IIF(EMPTY(M.size1), 1, VAL(M.size1))
          width = IIF(EMPTY(M.size2), LEN(M.expr)-2, VAL(M.size2))
          spacing = IIF(EMPTY(M.size3), 0, VAL(M.size3))
          IF 'T'$M.stylech
             mode = 1
          ELSE
             mode = 0
          ENDIF
          DO spojpicfun
          DO case
             CASE LEN(M.picture)<4
                objtype = 15
             CASE UPPER(SUBSTR(M.picture, 2, 3))=='@*R'
                objtype = 13
                objcode = 1
                initialnum = VAL(M.default)
             CASE UPPER(SUBSTR(M.picture, 2, 3))=='@*C'
                objtype = 14
                objcode = 1
                initialnum = IIF(TYPE(M.default)='L',  ;
                             IIF(EVALUATE(M.default), 1, 0), VAL(M.default))
             CASE UPPER(SUBSTR(M.picture, 2, 3))=='@*I'
                objtype = 20
                objcode = 1
             CASE UPPER(SUBSTR(M.picture, 2, 2))=='@*'
                objtype = 12
                objcode = 1
                initialnum = VAL(M.default)
             CASE UPPER(SUBSTR(M.picture, 2, 2))=='@^'
                objtype = 16
                IF EMPTY(M.from)
                   objcode = 1
                ELSE
                   objcode = 3
                   insexpr = M.from
                ENDIF
                IF  .not. EMPTY(M.default)
                   IF TYPE(M.default)='C'
                      initialval = M.default
                   ELSE
                      initialnum = VAL(M.default)
                   ENDIF
                ENDIF
             CASE UPPER(SUBSTR(M.picture, 2, 2))=='@&'
                objtype = 11
                objcode = 3
                IF  .not. EMPTY(M.from)
                   style = 0
                   insexpr = M.from
                ELSE
                   IF  .not. EMPTY(M.popup)
                      style = 1
                      insexpr = M.popup
                   ENDIF
                ENDIF
             OTHERWISE
                IF EMPTY(M.spiner1)
                   objtype = 15
                ELSE
                   objtype = 22
                   objcode = 1
                   initialval = M.spiner1
                ENDIF
          ENDCASE
          IF M.objtype=15
             IF M.cmd='EDIT'
                objcode = 2
             ELSE
                objcode = 1
             ENDIF
             IF TYPE(M.default)<>'U'
                fillchar = TYPE(M.default)
             ENDIF
          ENDIF
          IF M.picture=='"@^"'
             M.picture = '"@^ "'
          ENDIF
          IF INLIST(M.platform, 'DOS', 'UNIX')
             IF M.outvers='20'
                INSERT into (M.scrnalias) (comment, objtype, objcode,  ;
                       name, expr, vpos, hpos, height, width, picture,  ;
                       fillchar, lotype, hitype, whentype, validtype,  ;
                       errortype, messtype, scheme, colorpair, style,  ;
                       initialnum, initialval, rangelo, rangehi, when,  ;
                       valid, error, message, spacing, disabled) value  ;
                       (M.uniqueid, M.objtype, M.objcode, M.name,  ;
                       M.insexpr, koords(1), koords(2), M.height, M.width,  ;
                       M.picture, M.fillchar, M.lotype, M.hitype,  ;
                       M.whentype, M.validtype, M.errortype, M.messtype,  ;
                       M.scheme, M.colorpair, M.style, M.initialnum,  ;
                       M.initialval, M.rangelo, M.rangehi, M.when,  ;
                       M.valid, M.error, M.message, M.spacing, M.disabled)
             ELSE
                INSERT into (M.scrnalias) (platform, uniqueid, objtype,  ;
                       objcode, name, expr, vpos, hpos, height, width,  ;
                       picture, fillchar, mode, lotype, hitype, whentype,  ;
                       validtype, errortype, messtype, scheme, colorpair,  ;
                       style, initialnum, initialval, rangelo, rangehi,  ;
                       when, valid, error, message, spacing, disabled)  ;
                       value (M.platform, M.uniqueid, M.objtype,  ;
                       M.objcode, M.name, M.insexpr, koords(1), koords(2),  ;
                       M.height, M.width, M.picture, M.fillchar, M.mode,  ;
                       M.lotype, M.hitype, M.whentype, M.validtype,  ;
                       M.errortype, M.messtype, M.scheme, M.colorpair,  ;
                       M.style, M.initialnum, M.initialval, M.rangelo,  ;
                       M.rangehi, M.when, M.valid, M.error, M.message,  ;
                       M.spacing, M.disabled)
             ENDIF
          ELSE
             INSERT into (M.scrnalias) (platform, uniqueid, objtype,  ;
                    objcode, name, expr, vpos, hpos, height, width,  ;
                    picture, fillchar, mode, lotype, hitype, whentype,  ;
                    validtype, errortype, messtype, fillred, fillgreen,  ;
                    fillblue, penred, pengreen, penblue, fontface,  ;
                    fontstyle, fontsize, spacing, tag, tag2, style,  ;
                    initialnum, initialval, rangelo, rangehi, when, valid,  ;
                    error, message, disabled) value (M.platform,  ;
                    M.uniqueid, M.objtype, M.objcode, M.name, M.insexpr,  ;
                    koords(1), koords(2), M.height, M.width, M.picture,  ;
                    M.fillchar, M.mode, M.lotype, M.hitype, M.whentype,  ;
                    M.validtype, M.errortype, M.messtype, M.fillred,  ;
                    M.fillgreen, M.fillblue, M.penred, M.pengreen,  ;
                    M.penblue, M.fontface, M.fontstyle, M.fontsize,  ;
                    M.spacing, M.spiner2, M.spiner3, M.style,  ;
                    M.initialnum, M.initialval, M.rangelo, M.rangehi,  ;
                    M.when, M.valid, M.error, M.message, M.disabled)
          ENDIF
          RETURN .T.
       ENDIF
       RETURN .F.
    ENDIF
    IF (BETWEEN(M.tmp, 4, 5) .and. M.nkoords=2) .or. (M.tmp=6 .and.  ;
       M.nkoords=4)
       IF M.cmd=='FILL' .and.  .not. (UPPER(getnextwor())=='TO')
          RETURN .F.
       ENDIF
       IF M.cmd=='TO' .or. M.cmd=='FILL'
          size1 = VAL(getx())
          IF SUBSTR(M.line, M.linpos, 1)=','
             linpos = M.linpos+1
             size2 = VAL(getx())
          ELSE
             RETURN .F.
          ENDIF
          DO while M.linpos<LEN(M.line)
             word = UPPER(getnextwor())
             DO case
                CASE EMPTY(M.word)
                   expr = getx()
                CASE 'DOUBLE'=M.word
                   double = .T.
                CASE 'PANEL'=M.word
                   panel = .T.
                CASE 'COLOR'=M.word
                   DO getcolor
                CASE 'PATTERN'=M.word
                   pattern = getx()
                CASE 'PEN'=M.word
                   pen1 = getx()
                   IF SUBSTR(M.line, M.linpos, 1)=','
                      linpos = M.linpos+1
                      pen2 = getx()
                   ENDIF
                CASE 'STYLE'=M.word
                   stylech = getx()
             ENDCASE
          ENDDO
       ELSE
          expr = getx()
          size1 = koords(3)
          size2 = koords(4)
       ENDIF
       IF M.cmd=='FILL' .and.  .not. EMPTY(M.color)
          REPLACE scheme with M.scheme, colorpair with M.colorpair for  ;
                  objtype=7 .and. fillchar<>CHR(0) .and. vpos=koords(1)  ;
                  .and. hpos=koords(2) .and. height=M.size1-koords(1)+1  ;
                  .and. width=M.size2-koords(2)+1
          RETURN .T.
       ENDIF
       platform = IIF(EMPTY(M.codepart), M.koordtype, M.codepart)
       IF 'T'$M.stylech
          mode = 1
          stylech = STUFF(M.stylech, AT('T', M.stylech), 1, '')
       ELSE
          mode = 0
       ENDIF
       IF INLIST(M.platform, 'WINDOWS', 'MAC') .and. (koords(1)=M.size1  ;
          .or. koords(2)=M.size2) .and.  .not. EMPTY(M.pen1)
          objtype = 6
          objcode = 0
       ELSE
          objtype = 7
          objcode = 4
       ENDIF
       IF  .not. EMPTY(M.stylech)
          style = VAL(stripdelim(M.stylech))
       ENDIF
       IF INLIST(M.platform, 'WINDOWS', 'MAC') .or.  .not. EMPTY(M.pen1)  ;
          .or.  .not. EMPTY(M.pattern)
          height = M.size1-koords(1)
          width = M.size2-koords(2)
          IF M.height=0
             height = MAX(VAL(M.pen1)*0.077, 0.077)
          ENDIF
          IF M.width=0
             width = MAX(VAL(M.pen1)*0.2, 0.2)
          ENDIF
       ELSE
          height = M.size1-koords(1)+1
          width = M.size2-koords(2)+1
       ENDIF
       STORE CHR(0) to boxchar, fillchar
       DO case
          CASE M.double
             objcode = 5
          CASE M.panel
             objcode = 6
             boxchar = CHR(219)
          CASE  .not. EMPTY(M.expr)
             IF TYPE(M.expr)='C'
                expr = EVALUATE(M.expr)
                IF LEN(M.expr)=1 .and. M.cmd=='TO'
                   objcode = 7
                   boxchar = M.expr
                ELSE
                   IF LEN(M.expr)>7 .and. M.cmd=='BOX'
                      DO case
                         CASE LEFT(M.expr, 1)=CHR(201)
                            objcode = 5
                         CASE LEFT(M.expr, 1)=CHR(219)
                            objcode = 6
                            boxchar = CHR(219)
                         CASE LEFT(M.expr, 1)<>CHR(218)
                            objcode = 7
                            boxchar = LEFT(M.expr, 1)
                      ENDCASE
                      IF LEN(M.expr)=9
                         fillchar = RIGHT(M.expr, 1)
                      ENDIF
                   ENDIF
                ENDIF
             ENDIF
       ENDCASE
       IF M.picture=='"@^"'
          M.picture = '"@^ "'
       ENDIF
       IF INLIST(M.platform, 'DOS', 'UNIX')
          IF M.outvers='20'
             INSERT into (M.scrnalias) (objtype, objcode, vpos, hpos,  ;
                    height, width, boxchar, fillchar, scheme, colorpair)  ;
                    value (M.objtype, M.objcode, koords(1), koords(2),  ;
                    M.height, M.width, M.boxchar, M.fillchar, M.scheme,  ;
                    M.colorpair)
          ELSE
             INSERT into (M.scrnalias) (platform, uniqueid, objtype,  ;
                    objcode, vpos, hpos, height, width, boxchar, fillchar,  ;
                    scheme, colorpair) value (M.platform, SYS(2015),  ;
                    M.objtype, M.objcode, koords(1), koords(2), M.height,  ;
                    M.width, M.boxchar, M.fillchar, M.scheme, M.colorpair)
          ENDIF
       ELSE
          IF M.outvers='20'
             RETURN .F.
          ENDIF
          INSERT into (M.scrnalias) (platform, uniqueid, objtype, objcode,  ;
                 vpos, hpos, height, width, mode, fillred, fillgreen,  ;
                 fillblue, penred, pengreen, penblue, style, fillpat,  ;
                 pensize, penpat) value (M.platform, SYS(2015), M.objtype,  ;
                 M.objcode, koords(1), koords(2), M.height, M.width,  ;
                 M.mode, M.fillred, M.fillgreen, M.fillblue, M.penred,  ;
                 M.pengreen, M.penblue, M.style, VAL(M.pattern),  ;
                 VAL(M.pen1), VAL(M.pen2))
       ENDIF
       RETURN .T.
    ENDIF
 ELSE
    RETURN .F.
 ENDIF
 RETURN .T.

FUNCTION gettext
 PARAMETER inpline
 PRIVATE znak, i, closchar, text
 znak = LEFT(M.inpline, 1)
 IF M.znak$["'[]
    closchar = IIF(M.znak='[', ']', M.znak)
    text = M.znak
    FOR i = 2 to LEN(M.inpline)
       IF SUBSTR(M.inpline, M.i, 1)<>M.closchar
          text = M.text+SUBSTR(M.inpline, M.i, 1)
       ELSE
          text = M.text+M.closchar
          EXIT
       ENDIF
    ENDFOR
    RETURN M.text
 ENDIF
 RETURN ''

PROCEDURE getcolor
 PRIVATE tmp, barva, eobarva
 color = 'DEFINED'
 DO while M.linpos<=LEN(M.line)
    = skipbl_eol()
    IF SUBSTR(M.line, M.linpos, 1)<>','
       EXIT
    ENDIF
    linpos = M.linpos+1
 ENDDO
 tmp = M.linpos
 barva = UPPER(getnextwor())
 IF 'SCHEME'=M.barva
    scheme = VAL(getx())
    IF SUBSTR(M.line, M.linpos, 1)<>','
       RETURN
    ENDIF
    linpos = M.linpos+1
    scheme2 = VAL(getx())
 ELSE
    IF M.barva=='RGB'
       = skipbl_eol()
       tmp = M.linpos
       barva = getx()
       eobarva = M.linpos
       IF LEFT(M.barva, 1)='(' .and. RIGHT(M.barva, 1)=')'
          linpos = M.tmp+1
          tmp = getx()
          IF  .not. EMPTY(M.tmp)
             penred = VAL(M.tmp)
          ENDIF
          IF SUBSTR(M.line, M.linpos, 1)<>','
             RETURN
          ENDIF
          linpos = M.linpos+1
          tmp = getx()
          IF  .not. EMPTY(M.tmp)
             pengreen = VAL(M.tmp)
          ENDIF
          IF SUBSTR(M.line, M.linpos, 1)<>','
             RETURN
          ENDIF
          linpos = M.linpos+1
          tmp = getx()
          IF  .not. EMPTY(M.tmp)
             penblue = VAL(M.tmp)
          ENDIF
          IF SUBSTR(M.line, M.linpos, 1)<>','
             RETURN
          ENDIF
          linpos = M.linpos+1
          tmp = getx()
          IF  .not. EMPTY(M.tmp)
             fillred = VAL(M.tmp)
          ENDIF
          IF SUBSTR(M.line, M.linpos, 1)<>','
             RETURN
          ENDIF
          linpos = M.linpos+1
          tmp = getx()
          IF  .not. EMPTY(M.tmp)
             fillgreen = VAL(M.tmp)
          ENDIF
          IF SUBSTR(M.line, M.linpos, 1)<>','
             RETURN
          ENDIF
          linpos = M.linpos+1
          tmp = getx()
          IF  .not. EMPTY(M.tmp)
             fillblue = VAL(M.tmp)
          ENDIF
          IF SUBSTR(M.line, M.linpos, 1)<>','
             RETURN
          ENDIF
          linpos = M.eobarva
       ENDIF
    ELSE
       linpos = M.tmp
       DO while M.linpos<=LEN(M.line)
          = skipbl_eol()
          IF SUBSTR(M.line, M.linpos, 1)<>','
             EXIT
          ENDIF
          linpos = M.linpos+1
       ENDDO
       DO while M.linpos<=LEN(M.line) .and.  .not. (SUBSTR(M.line,  ;
          M.linpos, 1)$' '+CHR(9))
          colorpair = M.colorpair+SUBSTR(M.line, M.linpos, 1)
          linpos = M.linpos+1
       ENDDO
    ENDIF
 ENDIF

FUNCTION getknum
 PARAMETER ok
 PRIVATE text
 text = ''
 DO while M.linpos<=LEN(M.line)
    IF ISDIGIT(SUBSTR(M.line, M.linpos, 1)) .or. (SUBSTR(M.line, M.linpos,  ;
       1)='.' .and. AT('.', M.text)=0)
       text = M.text+SUBSTR(M.line, M.linpos, 1)
    ELSE
       EXIT
    ENDIF
    linpos = M.linpos+1
 ENDDO
 ok =  .not. EMPTY(M.text)
 IF M.ok
    koordtype = IIF('.'$M.text, 'WINDOWS', 'DOS')
 ENDIF
 RETURN VAL(M.text)

FUNCTION getnum
 PRIVATE text, znak
 text = ''
 DO while M.linpos<=LEN(M.line)
    znak = SUBSTR(M.line, M.linpos, 1)
    IF ISDIGIT(M.znak) .or. (M.znak='.' .and. AT('.', M.text)=0 .and.  ;
       AT('E', UPPER(M.text))=0) .or. (UPPER(M.znak)='E' .and. AT('E',  ;
       UPPER(M.text))=0) .or. (M.znak='+' .and. AT('E', UPPER(M.text))>0  ;
       .and. AT('+', M.text)=0 .and. AT('-', M.text)=0) .or. (M.znak='-'  ;
       .and. AT('E', UPPER(M.text))>0 .and. AT('+', M.text)=0 .and. AT( ;
       '-', M.text)=0)
       text = M.text+M.znak
    ELSE
       EXIT
    ENDIF
    linpos = M.linpos+1
 ENDDO
 RETURN M.text

PROCEDURE iswinkoord
 PARAMETER text
 return = '.'$M.text

FUNCTION inword
 PARAMETER w1, w2, w3, w4, w5, w6
 PRIVATE tmp, i
 FOR i = 1 to PARAMETERS()
    tmp = M.linpos
    IF testnextwo(EVALUATE('w'+ALLTRIM(STR(M.i))))
       RETURN M.i
    ENDIF
    linpos = M.tmp
 ENDFOR
 RETURN 0

FUNCTION issayexpr
 PARAMETER text
 IF (LEFT(M.text, 1)<>RIGHT(M.text, 1) .and. LEFT(M.text, 1)<>'[') .or.   ;
    .not. (LEFT(M.text, 1)$["'[])
    RETURN .T.
 ENDIF
 PRIVATE pos, znak, closchar
 pos = 1
 DO while .T.
    znak = SUBSTR(M.text, M.pos, 1)
    IF M.znak$["'[]
       closchar = IIF(M.znak='[', ']', M.znak)
       pos = M.pos+1
       DO while M.pos<=LEN(M.text) .and. SUBSTR(M.text, M.pos, 1)<>M.closchar
          pos = M.pos+1
       ENDDO
       IF M.pos>LEN(M.text)
          RETURN .T.
       ENDIF
       pos = M.pos+1
    ELSE
       RETURN .T.
    ENDIF
    DO while M.pos<=LEN(M.text) .and. SUBSTR(M.text, M.pos, 1)$CHR(9)+' '
       pos = M.pos+1
    ENDDO
    IF M.pos>LEN(M.text)
       RETURN .F.
    ENDIF
    IF SUBSTR(M.text, M.pos, 1)<>'+'
       RETURN .T.
    ENDIF
    pos = M.pos+1
    DO while M.pos<=LEN(M.text) .and. SUBSTR(M.text, M.pos, 1)$CHR(9)+' '
       pos = M.pos+1
    ENDDO
    IF LEN(M.text)-M.pos<8 .or. UPPER(SUBSTR(M.text, M.pos, 7))<>'CHR(13)'
       RETURN .T.
    ENDIF
    pos = M.pos+7
    DO while M.pos<=LEN(M.text) .and. SUBSTR(M.text, M.pos, 1)$CHR(9)+' '
       pos = M.pos+1
    ENDDO
    IF M.pos>LEN(M.text) .or. SUBSTR(M.text, M.pos, 1)<>'+'
       RETURN .T.
    ENDIF
    pos = M.pos+1
    DO while M.pos<=LEN(M.text) .and. SUBSTR(M.text, M.pos, 1)$CHR(9)+' '
       pos = M.pos+1
    ENDDO
    IF M.pos>LEN(M.text)
       RETURN .T.
    ENDIF
 ENDDO

FUNCTION transaytex
 PARAMETER text
 IF (LEFT(M.text, 1)<>RIGHT(M.text, 1) .and. LEFT(M.text, 1)<>'[') .or.   ;
    .not. (LEFT(M.text, 1)$["'[])
    RETURN M.text
 ENDIF
 PRIVATE pos, znak, closchar, newtext
 pos = 1
 newtext = SUBSTR(M.text, M.pos, 1)
 DO while .T.
    znak = SUBSTR(M.text, M.pos, 1)
    IF M.znak$["'[]
       closchar = IIF(M.znak='[', ']', M.znak)
       pos = M.pos+1
       DO while M.pos<=LEN(M.text) .and. SUBSTR(M.text, M.pos, 1)<>M.closchar
          newtext = M.newtext+SUBSTR(M.text, M.pos, 1)
          pos = M.pos+1
       ENDDO
       IF M.pos>LEN(M.text)
          RETURN M.text
       ENDIF
       pos = M.pos+1
    ELSE
       RETURN M.text
    ENDIF
    DO while M.pos<=LEN(M.text) .and. SUBSTR(M.text, M.pos, 1)$CHR(9)+' '
       pos = M.pos+1
    ENDDO
    IF M.pos>LEN(M.text)
       RETURN M.newtext+M.closchar
    ENDIF
    IF SUBSTR(M.text, M.pos, 1)<>'+'
       RETURN M.text
    ENDIF
    pos = M.pos+1
    DO while M.pos<=LEN(M.text) .and. SUBSTR(M.text, M.pos, 1)$CHR(9)+' '
       pos = M.pos+1
    ENDDO
    IF LEN(M.text)-M.pos<8 .or. UPPER(SUBSTR(M.text, M.pos, 7))<>'CHR(13)'
       RETURN M.text
    ENDIF
    newtext = M.newtext+CHR(13)
    pos = M.pos+7
    DO while M.pos<=LEN(M.text) .and. SUBSTR(M.text, M.pos, 1)$CHR(9)+' '
       pos = M.pos+1
    ENDDO
    IF M.pos>LEN(M.text) .or. SUBSTR(M.text, M.pos, 1)<>'+'
       RETURN M.text
    ENDIF
    pos = M.pos+1
    DO while M.pos<=LEN(M.text) .and. SUBSTR(M.text, M.pos, 1)$CHR(9)+' '
       pos = M.pos+1
    ENDDO
    IF M.pos>LEN(M.text)
       RETURN M.text
    ENDIF
 ENDDO

PROCEDURE spojpicfun
 PRIVATE tmp, i, pic
 IF ('(LOCFILE('$UPPER(M.picture) .or. '(LOCF('$UPPER(M.picture)) .and.  ;
    'B'$LEFT(M.picture, 5)
    tmp = gettext(M.picture)
    tmp = LEFT(M.tmp, LEN(M.tmp)-1)
    pic = M.picture
    i = 1
    DO while M.i>0
       i = AT('(LOCFILE(', UPPER(M.pic))
       IF M.i>0
          tmp = M.tmp+stripdelim(gettext(SUBSTR(M.pic, M.i+9)))+';'
          pic = STUFF(M.pic, M.i, 5, '(xxxx')
       ELSE
          i = AT('(LOCF(', UPPER(M.pic))
          IF M.i>0
             tmp = M.tmp+stripdelim(gettext(SUBSTR(M.pic, M.i+6)))+';'
             pic = STUFF(M.pic, M.i, 5, '(xxxx')
          ENDIF
       ENDIF
    ENDDO
    picture = LEFT(M.tmp, LEN(M.tmp)-1)+'"'
    RETURN
 ENDIF
 picture = gettext(M.picture)
 IF  .not. EMPTY(gettext(M.function))
    IF EMPTY(M.picture)
       picture = '"@'+SUBSTR(M.function, 2, LEN(M.function)-2)+'"'
    ELSE
       IF  .not. EMPTY(M.picture)
          picture = SUBSTR(M.picture, 2, LEN(M.picture)-2)
       ENDIF
       IF ASC(M.picture)=64
          picture = '"@'+SUBSTR(M.function, 2, LEN(M.function)-2)+ ;
                    SUBSTR(M.picture, 2)+'"'
       ELSE
          picture = '"@'+SUBSTR(M.function, 2, LEN(M.function)-2)+' '+ ;
                    M.picture+'"'
       ENDIF
    ENDIF
 ENDIF

FUNCTION issys2015
 PARAMETER text
 PRIVATE i
 IF LEN(M.text)<10 .or. LEFT(M.text, 1)<>'_' .or.  .not.  ;
    BETWEEN(UPPER(SUBSTR(M.text, 2, 1)), 'N', 'Z')
    RETURN .F.
 ENDIF
 FOR i = 2 to 10
    IF  .not. (ISALPHA(SUBSTR(M.text, M.i, 1)) .or. ISDIGIT(SUBSTR(M.text,  ;
        M.i, 1)))
       RETURN .F.
    ENDIF
 ENDFOR
 RETURN .T.

PROCEDURE testfragme
 PARAMETER text, texttype, descr
 IF  .not. EMPTY(M.text)
    IF issys2015(M.text) .and. LEN(M.text)=12 .and. RIGHT(M.text, 2)='()'
       getarrayle = M.getarrayle+1
       DIMENSION getarray( M.getarrayle, 3)
       getarray( M.getarrayle, 1) = M.uniqueid
       getarray( M.getarrayle, 2) = M.descr
       getarray( M.getarrayle, 3) = UPPER(LEFT(M.text, 10))
       text = ''
    ELSE
       texttype = 0
    ENDIF
 ENDIF

FUNCTION stripdelim
 PARAMETER text
 IF LEFT(M.text, 1)$["'[]
    RETURN SUBSTR(M.text, 2, LEN(M.text)-2)
 ENDIF
 RETURN M.text

PROCEDURE defiwind
 PARAMETER definecmd
 PRIVATE word, wname, vpos, hpos, height, width, footer, title, halfh,  ;
         double, panel, none, system, border
 PRIVATE close, noclose, float, nofloat, grow, nogrow, mdi, nomdi,  ;
         minimize, shadow
 PRIVATE zoom, nozoom, icon, fill, fillfile, from1, from2, to1, to2, at1,  ;
         at2, size1, size2
 PRIVATE penred, pengreen, penblue, fillred, fillgreen, fillblue, pensize
 PRIVATE penpat, fillpat, fontface, fontstyle, fontsize, fontsizech,  ;
         borderstr, stylech
 PRIVATE scheme, scheme2, colorpair, picture, order, style
 PRIVATE inscreen, indesktop, inwindow
 PRIVATE border, center, refresh, disabled, scrollbar, addalias, tab,  ;
         initialval
 PRIVATE initialnum, spacing, platform, objtype, objnum, objcode
 STORE '' to wname, footer, title, icon, fillfile, fontface, fontsizech,  ;
       borderstr, picture, order
 STORE .F. to halfh, double, panel, none, system, close, noclose, float,  ;
       nofloat, grow, nogrow, mdi, nomdi, minimize, shadow, zoom, nozoom,  ;
       inscreen, indesktop
 STORE .F. to center, tab
 STORE -1 to penred, pengreen, penblue, fillred, fillgreen, fillblue
 STORE '' to colorpair, from1, from2, to1, to2, at1, at2, size1, size2,  ;
       inwindow, stylech
 STORE 0 to vpos, hpos, height, width, scheme, scheme2
 STORE 1 to border
 style = IIF(M.definecmd, 1, 0)
 wname = getx()
 DO while M.linpos<LEN(M.line)
    word = UPPER(getnextwor())
    DO case
       CASE 'FROM'=M.word
          from1 = getx()
          IF SUBSTR(M.line, M.linpos, 1)=','
             linpos = M.linpos+1
             from2 = getx()
          ENDIF
       CASE 'TO'=M.word
          to1 = getx()
          IF SUBSTR(M.line, M.linpos, 1)=','
             linpos = M.linpos+1
             to2 = getx()
          ENDIF
       CASE 'AT'=M.word
          at1 = getx()
          IF SUBSTR(M.line, M.linpos, 1)=','
             linpos = M.linpos+1
             at2 = getx()
          ENDIF
       CASE 'SIZE'=M.word
          size1 = getx()
          IF SUBSTR(M.line, M.linpos, 1)=','
             linpos = M.linpos+1
             size2 = getx()
          ENDIF
       CASE 'IN'=M.word
          word = UPPER(getnextwor())
          DO case
             CASE 'SCREEN'=M.word
                inscreen = .T.
             CASE 'DESKTOP'=M.word
                indesktop = .T.
             CASE 'WINDOW'=M.word
                inwindow = getx()
             OTHERWISE
                IF EMPTY(M.word)
                   inwindow = getx()
                ELSE
                   inwindow = M.word
                ENDIF
          ENDCASE
       CASE 'TITLE'=M.word
          title = getx()
       CASE 'FOOTER'=M.word
          footer = getx()
       CASE 'FONT'=M.word
          fontface = getx()
          IF SUBSTR(M.line, M.linpos, 1)=','
             linpos = M.linpos+1
             fontsizech = getx()
          ENDIF
       CASE 'STYLE'=M.word
          stylech = UPPER(getx())
       CASE 'COLOR'=M.word
          DO getcolor
       CASE 'HALFHEIGHT'=M.word
          halfh = .T.
          tab = .T.
       CASE 'NONE'=M.word
          border = 0
       CASE 'DOUBLE'=M.word
          border = 2
       CASE 'PANEL'=M.word
          border = 3
       CASE 'SYSTEM'=M.word
          border = 4
       CASE 'CLOSE'=M.word
          close = .T.
       CASE 'NOCLOSE'=M.word
          close = .F.
       CASE 'FLOAT'=M.word
          float = .T.
       CASE 'NOFLOAT'=M.word
          float = .F.
       CASE 'GROW'=M.word
          grow = .T.
       CASE 'NOGROW'=M.word
          grow = .F.
       CASE 'MDI'=M.word
          mdi = .T.
       CASE 'NOMDI'=M.word
          mdi = .F.
       CASE 'ZOOM'=M.word
          zoom = .T.
       CASE 'NOZOOM'=M.word
          zoom = .F.
       CASE 'MINIMIZE'=M.word
          minimize = .T.
       CASE 'NOMINIMIZE'=M.word
          minimize = .F.
       CASE 'SHADOW'=M.word
          shadow = .T.
       CASE 'NOSHADOW'=M.word
          shadow = .F.
       CASE 'ICON'=M.word
          word = UPPER(getnextwor())
          IF 'FILE'=M.word
             icon = getx()
          ENDIF
       CASE 'FILL'=M.word
          word = UPPER(getnextwor())
          IF 'FILE'=M.word
             fillfile = getx()
          ELSE
             IF EMPTY(M.word)
                fill = getx()
             ELSE
                fill = M.word
             ENDIF
          ENDIF
       CASE EMPTY(M.word)
          borderstr = getx()
       OTHERWISE
          borderstr = M.word
    ENDCASE
 ENDDO
 wnameclaus = M.wname
 IF issys2015(M.wname)
    wname = ''
 ENDIF
 IF 'INT((SROW'$UPPER(M.from1) .and. 'INT((SCOL'$UPPER(M.from2) .and.  ;
    'INT((SROW'$UPPER(M.to1) .and. 'INT((SCOL'$UPPER(M.to2)
    center = .T.
    height = VAL(SUBSTR(M.from1, AT('-', M.from1)+1))
    width = VAL(SUBSTR(M.from2, AT('-', M.from2)+1))
    koordtype = 'DOS'
 ELSE
    IF EMPTY(M.at1)
       height = VAL(M.to1)-VAL(M.from1)+1
       width = VAL(M.to2)-VAL(M.from2)+1
       vpos = VAL(M.from1)
       hpos = VAL(M.from2)
       koordtype = 'DOS'
    ELSE
       vpos = VAL(M.at1)
       hpos = VAL(M.at2)
       height = VAL(M.size1)
       width = VAL(M.size2)
       koordtype = 'WINDOWS'
    ENDIF
 ENDIF
 fontstyle = 0+IIF('B'$M.stylech, 1, 0)+IIF('I'$M.stylech, 2, 0)
 fontsize = IIF(EMPTY(M.fontsizech), 8, VAL(M.fontsizech))
 fontface = IIF(EMPTY(gettext(M.fontface)), M.fontface, SUBSTR(M.fontface,  ;
            2, LEN(M.fontface)-2))
 IF  .not. EMPTY(M.fillfile)
    picture = getlfname(M.fillfile)
 ENDIF
 IF  .not. EMPTY(M.icon)
    order = getlfname(M.icon)
 ENDIF
 DO case
    CASE M.float .and. M.shadow .and. M.border=2 .and. M.scheme=7
       style = 4
       scheme2 = 12
    CASE M.float .and. M.shadow .and. M.border=2 .and. M.scheme=5
       style = 3
       scheme2 = 6
    CASE M.float .and. M.shadow .and. M.close .and. M.minimize .and.  ;
         M.border=4 .and. M.scheme=8
       style = 2
       scheme2 = 9
    OTHERWISE
       IF M.scheme>0
          scheme2 = 2
       ENDIF
 ENDCASE
 platform = IIF(EMPTY(M.codepart), M.koordtype, M.codepart)
 GOTO 1
 IF INLIST(M.platform, 'DOS', 'UNIX')
    REPLACE name with M.wname, vpos with M.vpos, hpos with M.hpos, height  ;
            with M.height, width with M.width, style with M.style, tag  ;
            with M.title, tag2 with M.footer, float with M.float, close  ;
            with M.close, shadow with M.shadow, minimize with M.minimize,  ;
            border with M.border, scheme with M.scheme, scheme2 with  ;
            M.scheme2, center with M.center
    IF M.outvers<>'20'
       REPLACE platform with M.platform
    ENDIF
 ELSE
    IF M.outvers='20'
       RETURN
    ENDIF
    IF M.picture=='"@^"'
       M.picture = '"@^ "'
    ENDIF
    REPLACE platform with M.platform, name with M.wname, vpos with M.vpos,  ;
            hpos with M.hpos, height with M.height, width with M.width,  ;
            style with M.style, tag with M.title, float with M.float,  ;
            close with M.close, tab with M.tab, shadow with M.shadow,  ;
            minimize with M.minimize, border with M.border, fontstyle  ;
            with M.fontstyle, fontsize with M.fontsize, fontface with  ;
            M.fontface, order with M.order, picture with M.picture,  ;
            penred with M.penred, pengreen with M.pengreen, penblue with  ;
            M.penblue, fillred with M.fillred, fillgreen with M.fillgreen,  ;
            fillblue with M.fillblue
 ENDIF
 defiwind = .T.

FUNCTION getlfname
 PARAMETER expr
 IF UPPER(LEFT(M.expr, 8))='LOCFILE(' .or. UPPER(LEFT(M.expr, 5))='LOCF('
    RETURN gettext(SUBSTR(M.expr, AT('(', M.expr)+1))
 ENDIF
 IF UPPER(LEFT(M.expr, 9))='(LOCFILE(' .or. UPPER(LEFT(M.expr, 6))='(LOCF('
    RETURN gettext(SUBSTR(M.expr, AT('(', M.expr, 2)+1))
 ELSE
    RETURN M.expr
 ENDIF

PROCEDURE readcmd
 PRIVATE cycle, activate, deactivate, modal, withlist, show, valid, when
 PRIVATE activtype, deacttype, showtype, validtype, whentype
 PRIVATE object, timeout, save, nomouse, lock, nolock
 PRIVATE penred, pengreen, penblue, fillred, fillgreen, fillblue
 PRIVATE scheme, colorpair, uniqueid, clauses, tmp
 STORE '' to activate, deactivate, withlist, show, valid, when, object,  ;
       timeout, colorpair, tmp
 clauses = '* Additional READ Clauses:'
 STORE -1 to penred, pengreen, penblue, fillred, fillgreen, fillblue
 STORE 0 to scheme
 STORE .F. to cycle, modal, save, nomouse, lock, nolock
 STORE 1 to activtype, deacttype, showtype, validtype, whentype
 DO while M.linpos<LEN(M.line)
    word = UPPER(getnextwor())
    DO case
       CASE 'CYCLE'=M.word
          cycle = .T.
          clauses = M.clauses+' '+M.word
       CASE 'MODAL'=M.word
          modal = .T.
          clauses = M.clauses+' '+M.word
       CASE 'SAVE'=M.word
          save = .T.
          clauses = M.clauses+' '+M.word
       CASE 'NOMOUSE'=M.word
          nomouse = .T.
          clauses = M.clauses+' '+M.word
       CASE 'LOCK'=M.word
          lock = .T.
          clauses = M.clauses+' '+M.word
       CASE 'NOLOCK'=M.word
          nolock = .T.
          clauses = M.clauses+' '+M.word
       CASE 'ACTIVATE'=M.word or 'PAD'=M.word
          activate = getx()
       CASE 'DEACTIVATE'=M.word
          deactivate = getx()
       CASE 'SHOW'=M.word
          show = getx()
       CASE 'VALID'=M.word
          valid = getx()
       CASE 'WHEN'=M.word
          when = getx()
       CASE 'OBJECT'=M.word
          object = getx()
          clauses = M.clauses+' '+M.word+' '+M.object
       CASE 'TIMEOUT'=M.word
          timeout = getx()
          clauses = M.clauses+' '+M.word+' '+M.timeout
       CASE 'COLOR'=M.word
          DO getcolor
          clauses = M.clauses+' '+M.word+'...'
       CASE 'WITH'=M.word
          withlist = getx()
          DO while SUBSTR(M.line, M.linpos, 1)=','
             linpos = M.linpos+1
             withlist = M.withlist+','+getx()
          ENDDO
          clauses = M.clauses+' '+M.word+' '+M.withlist
       OTHERWISE
          IF EMPTY(M.word)
             tmp = getx()
          ELSE
             tmp = ''
          ENDIF
          clauses = M.clauses+' '+M.word+' '+M.tmp
    ENDCASE
 ENDDO
 GOTO 1
 uniqueid = IIF(M.outvers='20', comment, uniqueid)
 DO testfragme with M.activate, M.activtype, 'ACTIVATE'
 DO testfragme with M.deactivate, M.deacttype, 'DEACTIVATE'
 DO testfragme with M.valid, M.validtype, 'VALID'
 DO testfragme with M.when, M.whentype, 'WHEN'
 DO testfragme with M.show, M.showtype, 'SHOW'
 REPLACE activate with M.activate, deactivate with M.deactivate, valid  ;
         with M.valid, activtype with M.activtype, deacttype with  ;
         M.deacttype, validtype with M.validtype, when with M.when, show  ;
         with M.show, whentype with M.whentype, showtype with M.showtype
 DO puttmpline with CHR(13)+CHR(10)+M.clauses+CHR(13)+CHR(10)

FUNCTION procfun
 PRIVATE pname, apos, arow, snipet
 pname = UPPER(getnextwor())
 IF  .not. issys2015(M.pname)
    RETURN .F.
 ENDIF
 apos = ASCAN(getarray, M.pname)
 DO while M.apos>0
    IF ASUBSCRIPT(getarray, M.apos, 2)=3
       EXIT
    ENDIF
    apos = ASCAN(getarray, M.pname, M.apos+1)
 ENDDO
 IF M.apos=0
    RETURN .F.
 ENDIF
 arow = ASUBSCRIPT(getarray, M.apos, 1)
 IF M.outvers='20'
    LOCATE for comment=getarray(M.arow,1)
 ELSE
    LOCATE for uniqueid=getarray(M.arow,1)
 ENDIF
 IF  .not. FOUND()
    RETURN .F.
 ENDIF
 IF M.lastcmnt
    snipet = M.cmntblock+CHR(13)+CHR(10)
    lastcmnt = .F.
 ELSE
    snipet = ''
 ENDIF
 DO getcmd
 DO while  .not. M.eofinp
    DO case
       CASE testword1('PROCEDURE') .or. testword1('FUNCTION')
          EXIT
       CASE testchars('*')
          IF M.lastcmnt
             cmntblock = M.cmntblock+CHR(13)+CHR(10)+M.line
          ELSE
             cmntblock = M.line
             lastcmnt = .T.
          ENDIF
       OTHERWISE
          IF M.lastcmnt
             snipet = M.snipet+CHR(13)+CHR(10)+M.cmntblock
          ENDIF
          lastcmnt = .F.
          snipet = M.snipet+CHR(13)+CHR(10)+M.line
    ENDCASE
    DO getcmd
 ENDDO
 REPLACE (getarray(M.arow,2)) with M.snipet
 getarray( M.arow, 3) = ''
 RETURN .T.

PROCEDURE restofproc
 PRIVATE i
 FOR i = 1 to ALEN(getarray)/3
    IF  .not. EMPTY(getarray(M.i,3))
       IF M.outvers='20'
          REPLACE (getarray(M.arow,2)) with getarray(M.i,3)+'()',  ;
                  (name2type(getarray(M.arow,2))) with 0 for comment= ;
                  getarray(M.i,1)
       ELSE
          REPLACE (getarray(M.arow,2)) with getarray(M.i,3)+'()',  ;
                  (name2type(getarray(M.arow,2))) with 0 for uniqueid= ;
                  getarray(M.i,1)
       ENDIF
    ENDIF
 ENDFOR

FUNCTION name2type
 PARAMETER name
 DO case
    CASE UPPER(M.name)='RANGELO'
       RETURN 'LOTYPE'
    CASE UPPER(M.name)='RANGEHI'
       RETURN 'HITYPE'
    CASE UPPER(M.name)='WHEN'
       RETURN 'WHENTYPE'
    CASE UPPER(M.name)='VALID'
       RETURN 'VALIDTYPE'
    CASE UPPER(M.name)='ERROR'
       RETURN 'ERRORTYPE'
    CASE UPPER(M.name)='MESSAGE'
       RETURN 'MESSTYPE'
    CASE UPPER(M.name)='SHOW'
       RETURN 'SHOWTYPE'
    CASE UPPER(M.name)='ACTIVATE' or UPPER(M.name)='PAD'
       RETURN 'ACTIVTYPE'
    CASE UPPER(M.name)='DEACTIVATE'
       RETURN 'DEACTTYPE'
 ENDCASE
 RETURN ''

PROCEDURE setupclean
 PRIVATE buf
 = tmpseek(M.cleanuppos,0)
 = tmpseek2(0,0)
 DO while  .not. FEOF(M.ftmp)
    = FWRITE(M.ftmp2, FREAD(M.ftmp, 1024))
 ENDDO
 = FCHSIZE(M.ftmp, M.cleanuppos)
 DO closetmp
 DO closetmp2
 GOTO 1
 APPEND memo setupcode from (M.ftmpname)
 APPEND memo proccode from (M.ftmpname2)
 REPLACE setuptype with 1, proctype with 1
 DO deletmp
 DO deletmp2
 RETURN

PROCEDURE mpr2mnx
 PRIVATE setudf
 setudf = SET('UDFP')
 SET UDFPARMS to reference
 =gendbf()
 set udfp to &setudf

PROCEDURE tstoutfile
 PRIVATE tmpdir, answer, setsafe, setdefa
 outfile = IIF('.'$M.inpfile, LEFT(M.inpfile, AT('.', M.inpfile)),  ;
           M.inpfile+'.')+M.outext
 DO while  .not. EMPTY(M.outfile)
    IF ADIR(tmpdir, M.outfile)>0
       answer = gnerr_('Output file'+CHR(13)+M.outfile+CHR(13)+ ;
                'already exists.','\!\<Overwrite;\?\<Cancel;\<New name')
       IF M.answer=1
          RETURN
       ENDIF
       IF INLIST(M.answer, 0, 2)
          outfile = ''
          RETURN
       ENDIF
       setsafe = SET('SAFE')
       SET SAFETY off
       outfile = PUTFILE('Select output file:', M.outfile, M.outext)
       IF EMPTY(outfile)
          CANCEL
       ENDIF
       IF M.setsafe='ON'
          SET SAFETY on
       ENDIF
       IF M.outext$'SCXMNXPJX' .and.  .not. ('.'+M.outext$M.outfile)
          outfile = IIF('.'$M.outfile, LEFT(M.outfile, AT('.',  ;
                    M.outfile)), M.outfile+'.')+M.outext
       ENDIF
    ELSE
       RETURN
    ENDIF
 ENDDO
FUNCTION tstout2
 PRIVATE tmpdir, answer, setsafe
 outfile = LEFT(M.inpfile, RAT('\', M.inpfile))+M.fname
 DO while  .not. EMPTY(M.outfile)
    IF ADIR(tmpdir, M.outfile)>0
       answer = gnerr_('Output file'+CHR(13)+M.outfile+CHR(13)+ ;
                'already exists.','\!\<Overwrite;\<Skip;\?\<Cancel;\<New name')
       IF INLIST(M.answer, 1, 2)
          RETURN M.answer
       ENDIF
       IF INLIST(M.answer, 0, 3)
          outfile = ''
          RETURN 3
       ENDIF
       setsafe = SET('SAFE')
       SET SAFETY off
       outfile = PUTFILE('Select output file:', M.outfile)
       IF EMPTY(outfile)
          CANCEL
       ENDIF
       IF M.setsafe='ON'
          SET SAFETY on
       ENDIF
    ELSE
       RETURN 1
    ENDIF
 ENDDO
 RETURN 1
FUNCTION isfree
 PARAMETER disk, space
 PRIVATE olddefa, clusize, rightsize, status
 olddefa = SYS(5)+SYS(2003)
 SET DEFAULT to (LEFT(M.disk, 2))
 clusize = VAL(SYS(2022))
 rightsize = (CEILING(M.space/M.clusize)+1)*M.clusize
 status = M.rightsize<=DISKSPACE()
 SET DEFAULT to (M.olddefa)
 RETURN M.status

FUNCTION freaddw
 PARAMETER file
 PRIVATE dw
 dw = FREAD(M.file, 4)
 IF FERROR()<>0
    RETURN -1
 ENDIF
 RETURN ASC(M.dw)+256*ASC(SUBSTR(M.dw, 2, 1))+65536*ASC(SUBSTR(M.dw, 3,  ;
        1))+16777216*ASC(RIGHT(M.dw, 1))

FUNCTION atol
 PARAMETER text
 RETURN ASC(M.text)+256*ASC(SUBSTR(M.text, 2, 1))+65536*ASC(SUBSTR(M.text,  ;
        3, 1))+16777216*ASC(SUBSTR(M.text, 4, 1))

FUNCTION ltoa
 PARAMETER num
 PRIVATE text, i
 text = ''
 FOR i = 1 to 4
    text = text+CHR(MOD(M.num, 256))
    num = (M.num-MOD(M.num, 256))/256
 ENDFOR
 RETURN M.text

PROCEDURE openinp
 IF M.inp>0
    DO closeinp
 ENDIF
 IF  .not. EMPTY(M.inpfile)
    inp = FOPEN(M.inpfile)
    IF M.inp<=0
       DO gnerr_ with 'Can not open input file'+CHR(13)+M.inpfile
       inp = 0
    ENDIF
 ENDIF

PROCEDURE closeinp
 IF M.inp>0
    = FCLOSE(M.inp)
    inp = 0
 ENDIF

PROCEDURE creaout
 IF M.out>0
    DO closeout
 ENDIF
 PRIVATE tmpdir
 IF  .not. EMPTY(M.outfile)
    IF ADIR(tmpdir, M.outfile)>0
       DELETE file (M.outfile)
    ENDIF
    out = FCREATE(M.outfile)
    IF M.out<=0
       DO gnerr_ with 'Can not create output file'+CHR(13)+M.outfile+ ;
          CHR(13)+'Error: '+ALLTRIM(STR(FERROR()))
       out = 0
    ENDIF
 ENDIF

PROCEDURE closeout
 IF M.out>0
    = FCLOSE(M.out)
    out = 0
 ENDIF

FUNCTION creatmp
 IF M.ftmp>0
    DO closetmp
 ENDIF
 ftmpname = SYS(2023)+IIF(RIGHT(SYS(2023), 1)='\', '', '\')+SYS(3)+'.TMP'
 ftmp = FCREATE(M.ftmpname)
 RETURN M.ftmp>0

FUNCTION opentmp
 IF M.ftmp>0
    RETURN
 ENDIF
 IF EMPTY(M.ftmpname)
    RETURN creatmp()
 ENDIF
 ftmp = FOPEN(M.ftmpname, 2)
 RETURN M.ftmp>0

PROCEDURE closetmp
 IF M.ftmp>0
    = FCLOSE(M.ftmp)
 ENDIF
 ftmp = 0

PROCEDURE deletmp
 PRIVATE oldsafe
 IF M.ftmp>0
    DO closetmp
 ENDIF
 IF  .not. EMPTY(M.ftmpname)
    oldsafe = SET('SAFE')
    SET SAFETY off
    DELETE file (M.ftmpname)
    IF M.oldsafe='ON'
       SET SAFETY on
    ENDIF
 ENDIF
 ftmpname = ''

FUNCTION resettmp
 IF M.ftmp<=0
    RETURN -1
 ENDIF
 RETURN FCHSIZE(M.ftmp, 0)

FUNCTION tmpseekpos
 IF M.ftmp<=0
    RETURN -1
 ENDIF
 RETURN FSEEK(M.ftmp, 0, 1)

FUNCTION tmpseek
 PARAMETER p1, p2
 IF M.ftmp<=0
    RETURN -1
 ENDIF
 RETURN FSEEK(M.ftmp, p1, p2)

FUNCTION creatmp2
 IF M.ftmp2>0
    DO closetmp2
 ENDIF
 ftmpname2 = SYS(2023)+IIF(RIGHT(SYS(2023), 1)='\', '', '\')+SYS(3)+'.TMP'
 ftmp2 = FCREATE(M.ftmpname2)
 RETURN M.ftmp2>0

FUNCTION opentmp2
 IF M.ftmp2>0
    RETURN
 ENDIF
 IF EMPTY(M.ftmpname2)
    RETURN creatmp2()
 ENDIF
 ftmp2 = FOPEN(M.ftmpname2, 2)
 RETURN M.ftmp2>0

PROCEDURE closetmp2
 IF M.ftmp2>0
    = FCLOSE(M.ftmp2)
 ENDIF
 ftmp2 = 0

PROCEDURE deletmp2
 PRIVATE oldsafe
 IF M.ftmp2>0
    DO closetmp2
 ENDIF
 IF  .not. EMPTY(M.ftmpname2)
    oldsafe = SET('SAFE')
    SET SAFETY off
    DELETE file (M.ftmpname2)
    IF M.oldsafe='ON'
       SET SAFETY on
    ENDIF
 ENDIF
 ftmpname2 = ''

FUNCTION resettmp2
 IF M.ftmp2<=0
    RETURN -1
 ENDIF
 RETURN FCHSIZE(M.ftmp2, 0)

FUNCTION tmpseekpo2
 IF M.ftmp2<=0
    RETURN -1
 ENDIF
 RETURN FSEEK(M.ftmp2, 0, 1)

FUNCTION tmpseek2
 PARAMETER p1, p2
 IF M.ftmp2<=0
    RETURN -1
 ENDIF
 RETURN FSEEK(M.ftmp2, p1, p2)

PROCEDURE check2x
 PRIVATE hbytes, i, j, k, tmp, file
 file = M.inp
 = FSEEK(M.file, M._startofs)
 hbytes = FREAD(M.file, 10)
 fxpheading = LEFT(M.hbytes, 6)+CHR(1)+CHR(0)+CHR(0)+CHR(0)
 IF FERROR()<>0
    notfox = .T.
    RETURN
 ENDIF
 IF INLIST(ASC(SUBSTR(M.hbytes, 3, 1)), 254, 252)
    encrypted = .T.
    RETURN
 ENDIF
 vers20 = ASC(SUBSTR(M.hbytes, 5, 1))=10
 hbytes = RIGHT(M.hbytes, 4)
 nfiles_ = ASC(M.hbytes)+256*ASC(SUBSTR(M.hbytes, 2, 1))
 mainfile_ = ASC(SUBSTR(M.hbytes, 3, 1))+256*ASC(RIGHT(M.hbytes, 1))
 IF M.nfiles_<=M.mainfile_
    notfox = .T.
    RETURN
 ENDIF
 ptrtofiles = freaddw(M.file)
 ptrtoenvir = freaddw(M.file)
 IF INLIST(-1, M.ptrtofiles, M.ptrtoenvir)
    notfox = .T.
    RETURN
 ENDIF
 ptrtofiles = M.ptrtofiles+M._startofs
 ptrtoenvir = M.ptrtoenvir+M._startofs
 IF M.ptrtofiles>=M._leninp .or. M.ptrtoenvir>=M._leninp
    notfox = .T.
    RETURN
 ENDIF
 RETURN

PROCEDURE checkexe
 PRIVATE rsrc, itext, i, j, ptr1, ptr2, header, ofs1, ofs2, file
 rsrc = CHR(255)+CHR(127)+'RSRC'
 file = M.inp
 = FSEEK(M.file, -4, 2)
 ofs1 = IIF(FERROR()=0, freaddw(M.file), -1)
 IF M.ofs1=-1 .or. M.ofs1>M._leninp-7000
    notfox = .T.
    RETURN
 ENDIF
 ptr1 = FSEEK(M.file, -M.ofs1-4, 2)
 ofs2 = IIF(FERROR()=0, freaddw(M.file), -1)
 IF M.ofs2=-1 .or. FERROR()<>0
    notfox = .T.
    RETURN
 ENDIF
 ptr1 = M.ptr1+4
 header = FREAD(M.file, 6)
 IF FERROR()<>0
    notfox = .T.
    RETURN
 ENDIF
 IF M.header==M.rsrc
    ptr2 = FSEEK(M.file, -M.ofs1-M.ofs2, 2)
    header = FREAD(M.file, 4)
    IF FERROR()<>0 .or. LEN(M.header)<4
       notfox = .T.
       RETURN
    ENDIF
    ptr1 = M.ptr2
 ELSE
    header = LEFT(M.header, 4)
 ENDIF
 IF LEFT(M.header, 2)=CHR(254)+CHR(242) .and. BETWEEN(ASC(SUBSTR(M.header,  ;
    3, 1)), 252, 255)
    _startofs = M.ptr1
    DO check2x
 ELSE
    notfox = .T.
 ENDIF
 RETURN

PROCEDURE maketables
 PRIVATE tmp, i, j, k
 = FSEEK(M.inp, M.ptrtoenvir)
 envtable = FREAD(M.inp, M.ptrtofiles-M.ptrtoenvir)
 tmp = M.envtable
 IF FERROR()<>0 .or. LEN(M.envtable)<>M.ptrtofiles-M.ptrtoenvir
    readerr = .T.
    RETURN
 ENDIF
 ftable = FREAD(M.inp, M.nfiles_*IIF(M.vers20, 26, 17))
 IF FERROR()<>0 .or. LEN(M.ftable)<>M.nfiles_*IIF(M.vers20, 26, 17)
    readerr = .T.
    RETURN
 ENDIF
 j = 0
 FOR i = 1 to M.nfiles_
    k = atol(SUBSTR(M.ftable, M.j+9+1, 4))+1
    DO while SUBSTR(M.envtable, M.k, 1)<>CHR(0)
       envtable = STUFF(M.envtable, M.k, 1, CHR(0))
       k = M.k+1
    ENDDO
    IF  .not. M.vers20
       k = atol(SUBSTR(M.ftable, M.j+13+1, 4))+1
       DO while SUBSTR(M.envtable, M.k, 1)<>CHR(0)
          envtable = STUFF(M.envtable, M.k, 1, CHR(0))
          k = M.k+1
       ENDDO
    ENDIF
    j = M.j+IIF(M.vers20, 26, 17)
 ENDFOR
 j = 0
 FOR i = 1 to LEN(M.envtable)
    IF SUBSTR(M.envtable, M.i, 1)<>CHR(0)
       j = M.j+1
       DIMENSION orignames( M.j)
       orignames( M.j) = ''
       DO while SUBSTR(M.envtable, M.i, 1)<>CHR(0)
          orignames( M.j) = orignames(M.j)+UPPER(SUBSTR(M.envtable, M.i, 1))
          i = M.i+1
       ENDDO
    ENDIF
 ENDFOR
 envtable = M.tmp
 tmp = .F.
 origdim = M.j

FUNCTION cpfile
 PARAMETER pfr, pto
 IF  .not. FILE(pto)
    COPY file (pfr) to (pto)
 ENDIF
 RETURN ''

FUNCTION xsum
 PARAMETER xs
 WAIT window 'checksum'
 RETURN SYS(2007, xs)

FUNCTION gettoken
 PARAMETER pstr, ppos
 WAIT window 'gettoken'
 pstr = ALLTRIM(pstr)+' '
 IF ppos<1
    RETURN ''
 ENDIF
 IF ppos=1
    RETURN SUBSTR(pstr, 1, IIF(AT(' ', pstr)>0, AT(' ', pstr)-1, LEN(pstr)))
 ENDIF
 ppos2 = AT(' ', pstr, ppos)
 IF ppos2=0
    RETURN ''
 ELSE
    RETURN ALLTRIM(SUBSTR(pstr, AT(' ', pstr, ppos-1), ppos2-ppos-1))
 ENDIF

FUNCTION gnerr_
 PARAMETER er_, options_
 IF .F.
 ENDIF
 PRIVATE i, size, stpos, mult, wsize, cbetw, sel, opt, nlines, maxlen, memow
 sel = 0
 RELEASE window __antique
 CLEAR typeahead
 IF TYPE('m.er_')='C'
    nlines = OCCURS(CHR(13), M.er_)+1
    memow = SET('MEMO')
    SET MEMOWIDTH to 200
    maxlen = 0
    FOR i = 1 to M.nlines
       maxlen = MAX(M.maxlen, LEN(MLINE(M.er_, M.i)))
    ENDFOR
    IF PARAMETERS()<2
       IF _WINDOWS
          DEFINE window __antique at 0, 0 size M.nlines+4, MAX(M.maxlen+5,  ;
                 35) font 'Courier', 10 float shadow title 'xPRgen' in  ;
                 screen double color scheme 7
          MOVE window __antique center
       ELSE
          DEFINE window __antique from INT(SROWS()/2-3), INT(SCOLS()/2- ;
                 MAX(M.maxlen/2+3, 18)) to INT(SROWS()/2+2+M.nlines),  ;
                 INT(SCOLS()/2+MAX(M.maxlen/2+3, 18)) float shadow in  ;
                 screen double color scheme 7
       ENDIF
       ACTIVATE window __antique
       FOR i = 1 to M.nlines
          @ M.i+1, 0 say PADC(MLINE(M.er_, M.i), WCOLS())
       ENDFOR
       = INKEY(10, 'HM')
    ELSE
       size = 0
       stpos = 1
       mult = OCCURS(';', M.options_)
       FOR i = 1 to M.mult
          opt = SUBSTR(M.options_, M.stpos)
          opt = LEFT(M.opt, AT(';', M.opt)-1)
          size = MAX(M.size, LEN(M.opt)-OCCURS('\', M.opt)*2)
          stpos = AT(';', M.options_, M.i)+1
       ENDFOR
       opt = SUBSTR(M.options_, M.stpos)
       size = MAX(M.size, LEN(M.opt)-OCCURS('\', M.opt)*2)+4
       wsize = MAX(M.maxlen+6, 36, (M.mult+1)*M.size+4+M.mult*5)
       IF M.mult>0
          cbetw = CEILING((M.wsize-(M.mult+1)*M.size-4)/M.mult)
          wsize = (M.mult+1)*M.size+3+M.mult*M.cbetw
       ELSE
          cbetw = 1
          wsize = M.wsize+1
       ENDIF
       IF _WINDOWS
          DEFINE window __antique at 0, 0 size M.nlines+5, M.wsize+1 font  ;
                 'Courier', 10 float shadow title 'xPRgen' in screen  ;
                 double color scheme 7
          MOVE window __antique center
       ELSE
          DEFINE window __antique from INT(SROWS()/2-3), INT((SCOLS()- ;
                 M.wsize)/2-1) to INT(SROWS()/2+2+M.nlines), INT((SCOLS()+ ;
                 M.wsize)/2+1) float shadow in screen double color scheme 7
       ENDIF
       ACTIVATE window __antique
       FOR i = 1 to M.nlines
          @ M.i, 0 say PADC(MLINE(M.er_, M.i), WCOLS())
       ENDFOR
       IF _DOS .or. _UNIX
          @ 2+M.nlines, IIF(M.mult>0, 2, (WCOLS()-M.size)/2) get M.sel  ;
          size 1.5, M.size, M.cbetw function '*H '+M.options_
       ELSE
          @ 2+M.nlines, IIF(M.mult>0, 2, (WCOLS()-M.size)/2) get M.sel  ;
          font 'MS Sans Serif', 10 style 'B' size 1.5, M.size, M.cbetw  ;
          function '*H '+M.options_
       ENDIF
       READ cycle modal
    ENDIF
    SET MEMOWIDTH to M.memow
    RELEASE window __antique
 ENDIF
 RETURN M.sel
 RETURN

PROCEDURE suspend_
 CANCEL
 RETURN

PROCEDURE gendbf
 PRIVATE prgfile, dbffile, prgcan, ioerror, endcode
 PRIVATE icurline, ilastline, inclprocs, menu_name, cnt_menus
 PRIVATE outvers
 DIMENSION menu_names(1)
 SET UDFPARMS to reference
 SET MEMOWIDTH to 256
 SET COMPATIBLE to foxplus
 path = SYS(2023)+IIF(RIGHT(SYS(2023), 1)='\', '', '\')
 prgin = M.path+'TEST.PRG'
 tempfile = M.path+'TEMP%%%.DBF'
 outfi_a = ''
 outfi_b = ''
 DO multinam with M.outfile, M.outfi_a, M.outfi_b
 menu_name = '_MSYSMENU'
 menu_names( 1) = menu_name
 cnt_menus = 1
 incl_comm = .T.
 icurline = 0
 ilastline = 0
 inclprocs = .T.
 generated = .T.
 IF  .not. M.generated
    inclprocs = .F.
 ENDIF
 ioerror = .F.
 prgcan = M.inp
 IF ioerror
    RETURN
 ENDIF
 outarea = SELECT(1)
 SELECT (M.outarea)
 IF isfree(M.outfile,5000)
    outvers = '25'
    oldsafe = SET('SAFE')
    SET SAFETY off
    COPY file ('MENUSTRU.DBF') to (M.outfile)
    COPY file ('MENUSTRU.FPT') to (LEFT(M.outfile,  ;
         LEN(M.outfile)-3)+'MNT')
    COPY file ('temp'+'.DBF') to (M.tempfile)
    COPY file ('temp'+'.FPT') to (LEFT(M.tempfile, LEN(M.tempfile)-3)+'FPT')
    IF M.oldsafe='ON'
       SET SAFETY on
    ENDIF
 ELSE
    DO gnerr_ with 'Insufficient disk space for'+CHR(13)+M.outfile
    DO deletmp
    RETURN
 ENDIF
 USE (M.outfile)
 APPEND blank
 workarea = SELECT(1)
 SELECT (M.workarea)
 USE (M.tempfile) alias workfile
 DELETE all
 PACK
 IF FILE(M.outfile+'.err')
    DELETE file (M.outfile+'.err')
 ENDIF
 SELECT (M.outarea)
 WAIT window nowait 'Analyzing the code ...  '
 line = ''
 endcode = .F.
 DO getsetup with M.line
 SELECT (M.workarea)
 IF M.generated
    DO while  .not. M.endcode
       IF LEN(M.line)=0 .or. iscomment(M.line)
          endcode = getline2(M.line)
          LOOP
       ENDIF
       IF UPPER(LEFT(M.line, 4))=='PROC'
          EXIT
       ENDIF
       IF  .not. ismenusect(M.line)
          EXIT
       ENDIF
       DO decode with M.line
       endcode = getline2(M.line)
    ENDDO
 ELSE
    DO while  .not. M.endcode
       IF LEN(M.line)=0 .or. iscomment(M.line)
          endcode = getline2(M.line)
          LOOP
       ENDIF
       IF UPPER(LEFT(M.line, 4))=='PROC' .or. ( .not. ismenusect(M.line))
          endcode = getline2(M.line)
          LOOP
       ENDIF
       DO decode with M.line
       endcode = getline2(M.line)
    ENDDO
 ENDIF
 SELECT (M.outarea)
 GOTO top
 IF  .not. M.endcode
    DO getcleanup with M.line
 ENDIF
 IF M.inclprocs
    DO while  .not. endcode
       IF UPPER(LEFT(M.line, 4))=='PROC'
          DO oneproc with M.line
       ELSE
          EXIT
       ENDIF
    ENDDO
 ENDIF
 = FCLOSE(M.prgcan)
 WAIT window  'Createing  MNX File... ' timeout 1.5
 IF M.generated
    DO onemenu
 ELSE
    DO moremenu
 ENDIF
 WAIT window  'OK, All Done' timeout 2
 SELECT (M.outarea)
 USE
 SELECT (M.workarea)
 USE
 RETURN
 RETURN

FUNCTION ismenusect
 PARAMETER line
 PRIVATE retcode, linep, word1
 retcode = .F.
 linep = UPPER(ALLTRIM(M.line))
 word1 = TRIM(SUBSTR(M.linep, 1, AT(' ', M.linep+' ')))
 DO case
    CASE M.word1=='ON' .and. INLIST(n2word(M.linep), 'BAR', 'PAD', 'SELE')
       retcode = .T.
    CASE M.word1=='SET' .and. AT(n2word(M.linep), 'SYSMENU')=1
       retcode = .T.
    CASE M.word1=='SET' .and. n2word(M.linep)=='MARK' .and.  ;
         n3word(M.linep)=='OF'
       retcode = .T.
    CASE (LEN(M.word1)>=4 .and. AT(M.word1, 'DEFINE')=1) .and.  ;
         INLIST(n2word(M.linep), 'BAR', 'PAD', 'POPU')
       retcode = .T.
    CASE LEN(M.word1)>=4 .and. AT(M.word1, 'PROCEDURE')=1
       retcode = .T.
 ENDCASE
 RETURN retcode

FUNCTION getline2
 PARAMETER line
 PRIVATE endcode
 line = ''
 endcode = .F.
 IF FEOF(M.prgcan)
    endcode = .T.
 ELSE
    line = FGETS(M.prgcan)
    ilastline = M.ilastline+1
    icurline = M.ilastline
    line = RTRIM(M.line)
    IF LEN(M.line)>0
       IF LEFT(LTRIM(M.line), 1)=='*'
       ELSE
          DO while .T.
             IF RIGHT(M.line, 1)==';'
                line = SUBSTR(M.line, 1, LEN(M.line)-1)
                IF FEOF(M.prgcan)
                   EXIT
                ELSE
                   line = M.line+FGETS(M.prgcan)
                   ilastline = M.ilastline+1
                ENDIF
             ELSE
                EXIT
             ENDIF
          ENDDO
          IF AT('&'+'&', ALLTRIM(M.line))>1
             line = TRIM(SUBSTR(M.line, 1, AT('&'+'&', M.line)-1))
          ENDIF
       ENDIF
       line = CHRTRAN(M.line, CHR(9), ' ')
    ENDIF
 ENDIF
 RETURN M.endcode

FUNCTION n2word
 PARAMETER line
 PRIVATE word, linep
 linep = UPPER(ALLTRIM(M.line))
 word = ''
 IF AT(' ', M.linep)>0
    word = ALLTRIM(SUBSTR(M.linep, AT(' ', M.linep)))
    IF AT(' ', M.word)>0
       word = TRIM(SUBSTR(M.word, 1, AT(' ', M.word)-1))
    ENDIF
    IF LEN(M.word)>4
       word = SUBSTR(M.word, 1, 4)
    ENDIF
 ENDIF
 RETURN M.word

FUNCTION n3word
 PARAMETER line
 PRIVATE word, linep
 linep = UPPER(ALLTRIM(M.line))
 word = ''
 IF AT(' ', M.linep)>0
    word = ALLTRIM(SUBSTR(M.linep, AT(' ', M.linep)))
    IF AT(' ', M.word)>0
       word = ALLTRIM(SUBSTR(M.word, AT(' ', M.word)))
       IF AT(' ', M.word)>0
          word = TRIM(SUBSTR(M.word, 1, AT(' ', M.word)-1))
       ENDIF
    ELSE
       word = ''
    ENDIF
    IF LEN(M.word)>4
       word = SUBSTR(M.word, 1, 4)
    ENDIF
 ENDIF
 RETURN M.word

PROCEDURE oneproc
 PARAMETER line
 PRIVATE pname, endcode, add_line, add_rev
 line = ALLTRIM(M.line)
 pname = ''
 IF AT(' ', M.line)>0
    pname = ALLTRIM(SUBSTR(M.line, AT(' ', M.line)))
 ENDIF
 SELECT (M.workarea)
 APPEND blank
 REPLACE word1 with 'PROC'
 REPLACE word2 with M.pname
 REPLACE resttxt with ''
 endcode = getline2(M.line)
 add_rev = .T.
 DO while  .not. M.endcode
    IF UPPER(LEFT(LTRIM(M.line), 4))=='PROC'
       EXIT
    ENDIF
    add_line = M.add_rev
    IF LEN(ALLTRIM(M.line))=0
       add_line = .F.
    ELSE
       IF SUBSTR(ALLTRIM(M.line), 1, 1)=='*'
          IF M.incl_comm
             IF LEN(ALLTRIM(M.line))>=10 .and. SUBSTR(ALLTRIM(M.line), 1,  ;
                10)=='*       **'
                add_rev = .F.
                add_line = .F.
             ENDIF
          ELSE
             add_line = .F.
          ENDIF
       ELSE
          add_line = .T.
       ENDIF
    ENDIF
    IF M.add_line
       IF ALLTRIM(resttxt)==''
          REPLACE resttxt with TRIM(M.line)
       ELSE
          REPLACE resttxt with resttxt+CHR(13)+CHR(10)+TRIM(M.line)
       ENDIF
    ENDIF
    endcode = getline2(M.line)
 ENDDO
 RETURN

FUNCTION iscomment
 PARAMETER line
 PRIVATE asterisk, isnote, ampersand, statement
 IF EMPTY(M.line)
    RETURN .F.
 ENDIF
 statement = UPPER(ALLTRIM(M.line))
 asterisk = AT('*', LEFT(M.statement, 1))
 ampersand = AT('&'+'&', LEFT(M.statement, 2))
 isnote = AT('NOTE', LEFT(M.statement, 4))
 DO case
    CASE (M.asterisk=1 .or. M.ampersand=1)
       RETURN .T.
    CASE (M.isnote=1 .and. (LEN(M.statement)<=4 .or. SUBSTR(M.statement,  ;
         5, 1)=' '))
       RETURN .T.
 ENDCASE
 RETURN .F.

PROCEDURE decode
 PARAMETER line
 PRIVATE statement, word, lirest
 statement = ALLTRIM(M.line)
 IF LEN(TRIM(M.statement))=0
    RETURN
 ENDIF
 APPEND blank
 REPLACE text with M.statement
 REPLACE problem with .F.
 REPLACE line with M.icurline
 word = ''
 lirest = ''
 DO firstw with M.statement, M.word, M.lirest
 REPLACE word1 with UPPER(SUBSTR(M.word, 1, 4))
 IF LEN(ALLTRIM(M.lirest))=0
    REPLACE problem with .T.
    RETURN
 ENDIF
 statement = M.lirest
 DO firstw with M.statement, M.word, M.lirest
 word = UPPER(M.word)
 REPLACE word2 with M.word
 IF LEN(ALLTRIM(M.lirest))=0
    REPLACE problem with .T.
    RETURN
 ENDIF
 statement = M.lirest
 DO firstw with M.statement, M.word, M.lirest
 REPLACE word3 with M.word
 statement = M.lirest
 DO case
    CASE TRIM(word1)=='DEFI'
       DO case
          CASE TRIM(word2)=='BAR' .or. TRIM(word2)=='PAD'
             IF LEN(ALLTRIM(M.statement))=0
                REPLACE problem with .T.
                RETURN
             ENDIF
             DO firstw with M.statement, M.word, M.lirest
             IF UPPER(M.word)=='OF'
                REPLACE word4 with 'OF'
                statement = M.lirest
                IF LEN(M.statement)=0
                   REPLACE problem with .T.
                   RETURN
                ENDIF
                DO firstw with M.statement, M.word, M.lirest
                REPLACE word5 with M.word
                statement = ALLTRIM(M.lirest)
                DO prest with M.statement
             ELSE
                REPLACE resttxt with M.statement
                REPLACE problem with .T.
                RETURN
             ENDIF
          CASE LEFT(word2, 4)=='POPU'
             statement = ALLTRIM(M.statement)
             DO prest with M.statement
          OTHERWISE
             REPLACE resttxt with M.statement
             REPLACE problem with .T.
             RETURN
       ENDCASE
    CASE TRIM(word1)=='ON'
       DO case
          CASE TRIM(word2)=='BAR' .or. TRIM(word2)=='PAD'
             IF LEN(M.statement)=0
                REPLACE problem with .T.
                RETURN
             ENDIF
             DO firstw with M.statement, M.word, M.lirest
             IF UPPER(M.word)=='OF'
                REPLACE word4 with 'OF'
                statement = M.lirest
                IF LEN(M.statement)=0
                   REPLACE problem with .T.
                   RETURN
                ENDIF
             ELSE
                REPLACE problem with .T.
                REPLACE resttxt with M.statement
                RETURN
             ENDIF
             DO firstw with M.statement, M.word, M.lirest
             REPLACE word5 with M.word
             statement = M.lirest
             IF LEN(M.statement)=0
                REPLACE comment with 'ACTIVATE clause must be present.'
                REPLACE problem with .T.
                RETURN
             ENDIF
             DO firstw with M.statement, M.word, M.lirest
             IF (UPPER(LEFT(M.word, 4))=='ACTI') or (UPPER(LEFT(M.word, 3))=='PAD')
                REPLACE word6 with 'ACTIVATE'
                statement = M.lirest
                IF LEN(M.statement)=0
                   REPLACE problem with .T.
                   RETURN
                ENDIF
             ELSE
                REPLACE problem with .T.
                REPLACE comment with 'ACTIVATE clause must be present.'
                REPLACE resttxt with M.statement
                RETURN
             ENDIF
             DO firstw with M.statement, M.word, M.lirest
             word = UPPER(M.word)
             IF TRIM(M.word)=='MENU'
                REPLACE word7 with 'MENU'
                REPLACE word8 with M.lirest
                REPLACE comment with  ;
                        '.. ACTIVATE MENU clause cannot be applicated.'
                REPLACE problem with .T.
                RETURN
             ENDIF
             IF LEFT(M.word, 4)=='POPU'
                REPLACE word7 with M.word
                statement = M.lirest
                IF LEN(M.statement)=0
                   REPLACE problem with .T.
                   RETURN
                ENDIF
             ELSE
                REPLACE problem with .T.
                REPLACE resttxt with M.statement
                RETURN
             ENDIF
             DO firstw with M.statement, M.word, M.lirest
             REPLACE word8 with M.word
             IF LEN(M.lirest)>0
                REPLACE resttxt with M.statement
                REPLACE problem with .T.
                RETURN
             ENDIF
          CASE LEFT(word2, 4)=='SELE'
             IF LEN(M.statement)=0
                REPLACE problem with .T.
                RETURN
             ENDIF
             DO firstw with M.statement, M.word, M.lirest
             REPLACE word3 with UPPER(word3)
             REPLACE word4 with M.word
             statement = M.lirest
             IF TRIM(word3)=='BAR' .or. TRIM(word3)=='PAD'
                IF LEN(M.statement)=0
                   REPLACE problem with .T.
                   RETURN
                ENDIF
                DO firstw with M.statement, M.word, M.lirest
                IF UPPER(M.word)=='OF'
                   REPLACE word5 with 'OF'
                   statement = M.lirest
                   IF LEN(M.statement)=0
                      REPLACE problem with .T.
                      RETURN
                   ENDIF
                   DO firstw with M.statement, M.word, M.lirest
                   REPLACE word6 with M.word
                   statement = M.lirest
                ELSE
                   REPLACE resttxt with ALLTRIM(M.statement)
                   REPLACE problem with .T.
                   RETURN
                ENDIF
             ENDIF
             REPLACE resttxt with ALLTRIM(M.statement)
             IF LEN(TRIM(M.statement))=0
                REPLACE problem with .T.
             ENDIF
             RETURN
          OTHERWISE
             REPLACE problem with .T.
             REPLACE resttxt with M.statement
             RETURN
       ENDCASE
    CASE TRIM(word1)=='SET'
       DO case
          CASE TRIM(word2)=='MARK'
             IF LEN(M.statement)=0
                REPLACE problem with .T.
                RETURN
             ENDIF
             DO firstw with M.statement, M.word, M.lirest
             statement = M.lirest
             REPLACE word4 with UPPER(TRIM(M.word))
             word = TRIM(LEFT(UPPER(M.word), 4))
             IF  .not. INLIST(M.word, 'MENU', 'PAD', 'POPU', 'BAR')
                REPLACE problem with .T.
                REPLACE resttxt with M.statement
                RETURN
             ENDIF
             REPLACE word3 with UPPER(word3)
             IF LEN(M.statement)=0
                REPLACE problem with .T.
                RETURN
             ENDIF
             DO firstw with M.statement, M.word, M.lirest
             REPLACE word5 with M.word
             statement = M.lirest
             IF LEN(M.statement)=0
                REPLACE problem with .T.
                RETURN
             ENDIF
             IF TRIM(word4)=='PAD' .or. TRIM(word4)=='BAR'
                DO firstw with M.statement, M.word, M.lirest
                IF TRIM(UPPER(M.word))=='OF'
                   statement = M.lirest
                   REPLACE word6 with 'OF'
                   IF LEN(M.statement)=0
                      REPLACE problem with .T.
                      RETURN
                   ENDIF
                   DO firstw with M.statement, M.word, M.lirest
                   statement = M.lirest
                   REPLACE word7 with M.word
                   IF LEN(M.statement)=0
                      REPLACE problem with .T.
                      RETURN
                   ENDIF
                ELSE
                   REPLACE problem with .T.
                   REPLACE resttxt with M.statement
                   RETURN
                ENDIF
             ENDIF
             DO firstw with M.statement, M.word, M.lirest
             IF TRIM(UPPER(M.word))=='TO'
                lirest = ALLTRIM(M.lirest)
                IF LEN(TRIM(M.statement))>0
                   IF TRIM(word4)=='MENU' .or. LEFT(word4, 4)=='POPU'
                      REPLACE word6 with 'TO'
                      REPLACE word7 with ALLTRIM(M.lirest)
                   ELSE
                      REPLACE word8 with 'TO'
                      REPLACE word9 with ALLTRIM(M.lirest)
                   ENDIF
                   IF M.generated
                      IF UPPER(TRIM(word4))<>'MENU'
                         REPLACE problem with .T.
                         REPLACE comment with  ;
                                 'Only SET MARK OF MENU .. can be used in generated programs.'
                      ENDIF
                   ELSE
                      IF UPPER(TRIM(word4))=='PAD'
                         REPLACE problem with .T.
                         REPLACE comment with  ;
                                 'Mark defined by SET MARK OF PAD .. cannot be used.'
                      ENDIF
                   ENDIF
                   IF TYPE(M.lirest)='C' .or. TYPE(M.lirest)='U'
                      RETURN
                   ELSE
                      IF LEN(TRIM(comment))=0
                         REPLACE comment with  ;
                                 'Only character expresion can be used in the TO clause.'
                      ENDIF
                      REPLACE problem with .T.
                      RETURN
                   ENDIF
                ELSE
                   REPLACE problem with .T.
                   RETURN
                ENDIF
             ELSE
                REPLACE problem with .T.
                REPLACE resttxt with M.statement
                RETURN
             ENDIF
          CASE LEFT(word2, 4)=='SYSM'
             DO case
                CASE TRIM(UPPER(word3))=='TO'
                   IF LEN(TRIM(M.statement))=0
                   ELSE
                      REPLACE problem with .T.
                      IF UPPER(LEFT(M.statement, 4))=='DEFA'
                         REPLACE word4 with 'DEFAULT'
                      ELSE
                         REPLACE resttxt with ALLTRIM(M.statement)
                      ENDIF
                   ENDIF
                   RETURN
                CASE LEFT(UPPER(word3), 4)=='AUTO'
                   REPLACE problem with .F.
                   RETURN
                OTHERWISE
                   REPLACE problem with .T.
                   REPLACE resttxt with M.statement
                   RETURN
             ENDCASE
          OTHERWISE
             REPLACE problem with .T.
             REPLACE resttxt with M.statement
             RETURN
       ENDCASE
 ENDCASE
 RETURN

PROCEDURE firstw
 PARAMETER statement, word, lirest
 PRIVATE ispace
 ispace = AT(' ', M.statement)
 IF M.ispace=0
    word = M.statement
    lirest = ''
 ELSE
    word = TRIM(LEFT(M.statement, M.ispace))
    lirest = LTRIM(SUBSTR(M.statement, M.ispace))
 ENDIF
 RETURN

PROCEDURE prest
 PARAMETER p_stmt
 PRIVATE defi_type, no_kwords, kwords( 1), det_kwords( 1)
 PRIVATE kword, kword_txt, statement, rest, ii
 PRIVATE ikword, ikword1, ikwordx, k1_len, xxx, xxxtext
 PRIVATE knext_s, knext_sx
 DO case
    CASE ALLTRIM(UPPER(word2))=='BAR'
       defi_type = 'BAR'
       no_kwords = 8
       DIMENSION kwords( 8), det_kwords( 8)
       kwords( 1) = 'PROMPT'
       kwords( 2) = 'BEFORE'
       kwords( 3) = 'AFTER'
       kwords( 4) = 'KEY'
       kwords( 5) = 'MARK'
       kwords( 6) = 'SKIP'
       kwords( 7) = 'MESSAGE'
       kwords( 8) = 'COLOR'
    CASE ALLTRIM(UPPER(word2))=='PAD'
       defi_type = 'PAD'
       no_kwords = 9
       DIMENSION kwords( 9), det_kwords( 9)
       kwords( 1) = 'PROMPT'
       kwords( 2) = 'BEFORE'
       kwords( 3) = 'AFTER'
       kwords( 4) = 'KEY'
       kwords( 5) = 'MARK'
       kwords( 6) = 'SKIP'
       kwords( 7) = 'MESSAGE'
       kwords( 8) = 'COLOR'
       kwords( 9) = 'AT'
    CASE LEFT(UPPER(word2), 4)=='POPU'
       defi_type = 'POPUP'
       no_kwords = 16
       DIMENSION kwords( 16), det_kwords( 16)
       kwords( 1) = 'FROM'
       kwords( 2) = 'TO'
       kwords( 3) = 'IN'
       kwords( 4) = 'FOOTER'
       kwords( 5) = 'KEY'
       kwords( 6) = 'MARGIN'
       kwords( 7) = 'MARK'
       kwords( 8) = 'MESSAGE'
       kwords( 9) = 'MOVER'
       kwords( 10) = 'MULTISELECT'
       kwords( 11) = 'PROMPT'
       kwords( 12) = 'RELATIVE'
       kwords( 13) = 'SCROLL'
       kwords( 14) = 'SHADOW'
       kwords( 15) = 'TITLE'
       kwords( 16) = 'COLOR'
 ENDCASE
 FOR ii = 1 to M.no_kwords
    det_kwords( M.ii) = .F.
 ENDFOR
 statement = ALLTRIM(M.p_stmt)
 IF LEN(M.statement)=0
    RETURN
 ENDIF
 REPLACE notappl with ''
 ikword = 0
 FOR ii = 1 to M.no_kwords
    IF LEN(kwords(M.ii))<=4
       IF AT(kwords(M.ii)+' ', UPPER(M.statement))=1
          ikword = M.ii
          EXIT
       ENDIF
    ELSE
       IF LEFT(kwords(M.ii), 4)==UPPER(LEFT(M.statement, 4))
          k1_len = AT(' ', M.statement+' ')-1
          IF UPPER(LEFT(M.statement, M.k1_len))==LEFT(kwords(M.ii), M.k1_len)
             ikword = M.ii
             EXIT
          ENDIF
       ENDIF
    ENDIF
 ENDFOR
 IF M.ikword=0
    REPLACE resttxt with M.statement
    REPLACE problem with .T.
    RETURN
 ENDIF
 kword = kwords(M.ikword)
 det_kwords( M.ikword) = .T.
 statement = ALLTRIM(SUBSTR(M.statement, AT(' ', M.statement+' ')))
 DO while .T.
    IF M.defi_type='POPUP' .and. INLIST(M.kword, 'MARGIN', 'MOVER',  ;
       'MULTISELECT', 'RELATIVE', 'SCROLL', 'SHADOW')
       kword_txt = ''
       ikword1 = 0
       FOR ii = 1 to M.no_kwords
          IF det_kwords(M.ii)
             LOOP
          ENDIF
          IF LEN(kwords(M.ii))<=4
             IF AT(kwords(M.ii)+' ', UPPER(M.statement))=1
                ikword1 = M.ii
                EXIT
             ENDIF
          ELSE
             IF LEFT(kwords(M.ii), 4)==UPPER(LEFT(M.statement, 4))
                k1_len = AT(' ', M.statement+' ')-1
                IF UPPER(LEFT(M.statement, M.k1_len))==LEFT(kwords(M.ii),  ;
                   M.k1_len)
                   ikword1 = M.ii
                   EXIT
                ENDIF
             ENDIF
          ENDIF
       ENDFOR
       rest = M.statement
       IF M.ikword1=0
          REPLACE resttxt with M.statement
          REPLACE problem with .T.
       ENDIF
    ELSE
       knext_s = 10000
       ikword1 = 0
       FOR ii = 1 to M.no_kwords
          IF det_kwords(M.ii)
             LOOP
          ENDIF
          knext_sx = 0
          ikwordx = 0
          IF LEN(kwords(M.ii))<=4
             xxx = AT(' '+kwords(M.ii)+' ', UPPER(M.statement))
             IF M.xxx>0
                knext_sx = M.xxx+1
                ikwordx = M.ii
             ENDIF
          ELSE
             xxx = AT(' '+LEFT(kwords(M.ii), 4), UPPER(M.statement))
             IF M.xxx>0
                xxx = M.xxx+1
                xxxtext = SUBSTR(M.statement, M.xxx)
                k1_len = AT(' ', M.xxxtext+' ')-1
                IF UPPER(LEFT(M.xxxtext, M.k1_len))==LEFT(kwords(M.ii),  ;
                   M.k1_len)
                   knext_sx = M.xxx
                   ikwordx = M.ii
                ENDIF
             ENDIF
          ENDIF
          IF M.kword=='SKIP'
             IF M.knext_sx>0 .and. M.knext_sx<M.knext_s
                knext_s = M.knext_sx
                ikword1 = M.ikwordx
             ENDIF
          ELSE
             IF M.knext_sx>1 .and. M.knext_sx<M.knext_s
                knext_s = M.knext_sx
                ikword1 = M.ikwordx
             ENDIF
          ENDIF
       ENDFOR
       IF M.knext_s=10000 .or. M.knext_s>LEN(ALLTRIM(M.statement))
          kword_txt = ALLTRIM(M.statement)
          rest = ''
       ELSE
          kword_txt = ALLTRIM(SUBSTR(M.statement, 1, M.knext_s-1))
          rest = ALLTRIM(SUBSTR(M.statement, M.knext_s))
       ENDIF
    ENDIF
    DO case
       CASE TRIM(word2)=='BAR' .or. TRIM(word2)=='PAD'
          DO case
             CASE M.kword=='PROMPT'
                REPLACE xprompt with 'PROMPT '+M.kword_txt
             CASE M.kword=='BEFORE' .or. M.kword=='AFTER'
                IF word2=='BAR'
                   REPLACE notappl with notappl+' '+M.kword+' '+M.kword_txt
                ELSE
                   IF M.kword=='BEFORE'
                      REPLACE xbefore with 'BEFORE '+M.kword_txt
                   ELSE
                      REPLACE xafter with 'AFTER '+M.kword_txt
                   ENDIF
                ENDIF
             CASE M.kword=='KEY'
                REPLACE xkey with 'KEY '+M.kword_txt
             CASE M.kword=='MARK'
                REPLACE xmark with 'MARK '+M.kword_txt
             CASE M.kword=='MESSAGE'
                REPLACE xmessage with 'MESSAGE '+M.kword_txt
             CASE M.kword=='SKIP'
                IF LEN(ALLTRIM(M.kword_txt))>0
                   REPLACE xskip with 'SKIP '+M.kword_txt
                ELSE
                   REPLACE xskip with 'SKIP FOR .F.'
                ENDIF
             CASE M.kword=='COLOR'
                IF UPPER(LEFT(M.kword_txt, 4))=='SCHE'
                   IF TRIM(word2)=='PAD'
                      REPLACE xcolor with 'COLOR '+M.kword_txt
                   ELSE
                      REPLACE notappl with notappl+' COLOR '+M.kword_txt
                   ENDIF
                ELSE
                   REPLACE notappl with notappl+' COLOR '+M.kword_txt
                ENDIF
             CASE M.kword=='AT'
                REPLACE notappl with notappl+' AT '+M.kword_txt
             OTHERWISE
                REPLACE notappl with notappl+' '+M.kword+' '+M.kword_txt
          ENDCASE
       CASE TRIM(word2)=='POPUP'
          DO case
             CASE M.kword=='KEY'
                REPLACE xkey with 'KEY '+M.kword_txt
             CASE M.kword=='MARGIN'
                REPLACE xmargin with 'MARGIN'
             CASE M.kword=='MARK'
                REPLACE xmark with 'MARK '+M.kword_txt
             CASE M.kword=='RELATIVE'
                REPLACE xrelative with 'RELATIVE'
             CASE M.kword=='SHADOW'
                REPLACE xshadow with 'SHADOW'
             CASE M.kword=='COLOR'
                IF UPPER(LEFT(M.kword_txt, 4))=='SCHE'
                   REPLACE xcolor with 'COLOR '+M.kword_txt
                ELSE
                   REPLACE notappl with notappl+' COLOR '+M.kword_txt
                ENDIF
             CASE M.kword=='FROM'
                REPLACE notappl with notappl+' FROM '+M.kword_txt
             CASE M.kword=='TO'
                REPLACE notappl with notappl+' TO '+M.kword_txt
             CASE M.kword=='IN'
                REPLACE notappl with notappl+' IN '+M.kword_txt
             CASE M.kword=='FOOTER'
                REPLACE notappl with notappl+' FOOTER '+M.kword_txt
             CASE M.kword=='MESSAGE'
                REPLACE notappl with notappl+' MESSAGE '+M.kword_txt
             CASE M.kword=='MOVER'
                REPLACE notappl with notappl+' MOVER'
             CASE M.kword=='MULTISELECT'
                REPLACE notappl with notappl+' MULTISELECT'
             CASE M.kword=='PROMPT'
                REPLACE notappl with notappl+' PROMPT '+M.kword_txt
             CASE M.kword=='SCROLL'
                REPLACE notappl with notappl+' SCROLL'
             CASE M.kword=='TITLE'
                REPLACE notappl with notappl+' TITLE '+M.kword_txt
             OTHERWISE
                REPLACE notappl with notappl+' '+M.kword+' '+M.kword_txt
          ENDCASE
       OTHERWISE
          REPLACE notappl with notappl+' '+M.word+' '+M.kword_txt
    ENDCASE
    statement = M.rest
    ikword = ikword1
    IF LEN(M.statement)=0 .or. ikword=0
       EXIT
    ENDIF
    kword = kwords(M.ikword)
    det_kwords( M.ikword) = .T.
    statement = ALLTRIM(SUBSTR(M.statement, AT(' ', M.statement+' ')))
 ENDDO
 RETURN

PROCEDURE generdb
 PRIVATE sysm_to, set_mark, set_color3, set_color4
 PRIVATE fil_d_bar, fil_o_bar, fil_d_pad, fil_o_pad, fil_d_ppu, fil_s_mar
 PRIVATE padcount, onbars, defppu, cnt, onmenu, nnppups
 PRIVATE l_before, l_after, w_befaft, ins_ppu, ppu_acti
 PRIVATE inum, ii, iii, jj, kk, ibar
 PRIVATE wtext, procname, takeproc, xrec, xrec_d, wpopup
 PRIVATE pop_name, pop_mark, bar_name, bar_mark
 PRIVATE pack_need, i_convert
 SELECT (M.workarea)
 SET FILTER to
 GOTO top
 LOCATE for TRIM(word1)=='SET' .and. LEFT(word2, 4)=='SYSM' .and.  ;
        TRIM(word3)=='TO' .and.  .not. problem .and. curmenu
 IF FOUND()
    sysm_to = .T.
 ELSE
    sysm_to = .F.
 ENDIF
 GOTO top
 LOCATE for TRIM(word1)=='SET' .and. TRIM(word2)=='MARK' .and.  ;
        TRIM(word3)=='OF' .and. TRIM(UPPER(word4))=='MENU' .and.  ;
        LEFT(UPPER(word5), 4)=='_MSY' .and. TRIM(UPPER(word6))=='TO'  ;
        .and.  .not. problem .and. curmenu
 set_mark = ''
 IF FOUND()
    IF word7==CHR(32)
       set_mark = CHR(0)
    ELSE
       set_mark = word7
       set_mark = &set_mark
    ENDIF
 ENDIF
 set_color3 = '3'
 set_color4 = '4'
 fil_d_bar = 'TRIM(word1)=="DEFI" .AND. TRIM(word2)=="BAR" .and. .not.problem .and. curmenu'
 fil_o_bar = 'TRIM(word1)=="ON"   .AND. TRIM(word2)=="BAR" .AND. TRIM(word4)=="OF"'+ ;
             ' .and. .not.problem .and. curmenu'
 fil_d_pad = 'TRIM(word1)=="DEFI" .AND. TRIM(word2)=="PAD" .and. .not.problem .and. curmenu'
 fil_o_pad = 'TRIM(word1)=="ON"   .AND. TRIM(word2)=="PAD" .AND. '+ ;
             ' UPPER(TRIM(word5))=="_MSYSMENU" .and. .not.problem .and. curmenu'
 fil_d_ppu = 'TRIM(word1)=="DEFI" .AND. TRIM(word2)=="POPUP" .and. .not.problem .and. curmenu'
 SET FILTER TO &fil_d_pad
 GOTO top
 COUNT to M.padcount
 IF M.padcount<=0
    RETURN
 ENDIF
 GOTO top
 DIMENSION npads( M.padcount), npopups( M.padcount)
 FOR ii = 1 to M.padcount
    npads( M.ii) = TRIM(word3)
    SKIP
 ENDFOR
 SET FILTER TO &fil_o_pad
 FOR ii = 1 to M.padcount
    GOTO top
    LOCATE for UPPER(TRIM(word3))==UPPER(npads(M.ii))
    npopups( M.ii) = ''
    IF FOUND()
       npopups( M.ii) = TRIM(word8)
    ENDIF
 ENDFOR
 SET FILTER TO &fil_o_bar
 GOTO top
 COUNT to M.onbars
 IF M.onbars>0
    DIMENSION nobar( M.onbars), noppup( M.onbars), noppup_ac( M.onbars),  ;
              isolved( M.onbars)
    GOTO top
    FOR ii = 1 to M.onbars
       nobar( M.ii) = TRIM(word3)
       noppup( M.ii) = TRIM(word5)
       noppup_ac( M.ii) = TRIM(word8)
       isolved( M.ii) = .F.
       SKIP
    ENDFOR
 ENDIF
 SET FILTER TO &fil_d_ppu
 GOTO top
 COUNT to M.defppu
 IF M.defppu>0
    DIMENSION def_ppups( M.defppu), def_pp_ini( M.defppu)
    GOTO top
    FOR ii = 1 to M.defppu
       def_ppups( M.ii) = TRIM(word3)
       def_pp_ini( M.ii) = .F.
       SKIP
    ENDFOR
 ENDIF
 IF M.defppu>0
    DIMENSION npop_bar( M.defppu)
    SET FILTER TO &fil_d_bar
    FOR ii = 1 to M.defppu
       GOTO top
       COUNT for UPPER(TRIM(word5))==UPPER(def_ppups(ii)) to M.cnt
       npop_bar( M.ii) = M.cnt
    ENDFOR
 ENDIF
 SET FILTER to
 GOTO top
 SELECT (M.outarea)
 REPLACE objtype with 1
 IF '20'$M.outvers
    REPLACE objcode with 20
 ELSE
    REPLACE objcode with 22
 ENDIF
 REPLACE itemnum with '  0'
 REPLACE proctype with 1
 REPLACE setuptype with 1
 REPLACE cleantype with 1
 REPLACE mark with M.set_mark
 l_before = .F.
 l_after = .F.
 w_befaft = ''
 IF M.sysm_to
    REPLACE location with 0
 ELSE
    REPLACE location with 1
    IF M.padcount>0
       DO test_bef
       IF M.l_before
          REPLACE location with 2
          REPLACE name with M.w_befaft
       ENDIF
       IF M.l_after
          REPLACE location with 3
          REPLACE name with M.w_befaft
       ENDIF
    ENDIF
 ENDIF
 APPEND blank
 REPLACE objtype with 2
 REPLACE objcode with 1
 REPLACE name with '_msysmenu'
 REPLACE levelname with '_msysmenu'
 REPLACE numitems with M.padcount
 REPLACE itemnum with '  0'
 REPLACE proctype with 1
 REPLACE mark with M.set_mark
 REPLACE namechange with .F.
 REPLACE scheme with VAL(M.set_color3)
 FOR inum = 1 to ALEN(M.npads)
    DO creappup with M.inum
    DO creabars with M.inum, .T.
 ENDFOR
 nnppups = 0
 FOR kk = 1 to M.onbars
    ins_ppu = ''
    FOR ii = 1 to M.onbars
       FOR jj = 1 to M.defppu
          IF UPPER(TRIM(noppup_ac(M.ii)))==UPPER(TRIM(def_ppups(M.jj)))  ;
             .and.  .not. def_pp_ini(M.jj)
             ins_ppu = noppup(M.ii)
             ppu_acti = noppup_ac(M.ii)
             def_pp_ini( M.jj) = .T.
             EXIT
          ENDIF
       ENDFOR
       IF LEN(M.ins_ppu)>0
          EXIT
       ENDIF
    ENDFOR
    IF LEN(ALLTRIM(M.ins_ppu))>0
       SELECT (M.outarea)
       GOTO top
       LOCATE for UPPER(TRIM(levelname))==UPPER(TRIM(noppup(M.ii))) .and.  ;
              objtype=3 .and. objcode=78 .and. UPPER(TRIM(name))== ;
              UPPER(TRIM(nobar(M.ii)))
       IF FOUND()
          isolved( M.ii) = .T.
          inum = M.ii
          DO inseppup with M.inum
          DO creabars with M.inum, .F.
          nnppups = M.nnppups+1
       ENDIF
    ENDIF
    IF M.nnppups=M.onbars
       EXIT
    ENDIF
 ENDFOR
 IF M.nnppups<M.onbars
    SELECT (M.workarea)
    SET FILTER TO &fil_o_bar
    FOR ibar = 1 to M.onbars
       IF isolved(M.ibar)
          LOOP
       ENDIF
       GOTO top
       LOCATE for UPPER(TRIM(word3))==UPPER(TRIM(nobar(M.ibar))) .and.  ;
              UPPER(TRIM(word5))==UPPER(TRIM(noppup(M.ibar))) .and.  ;
              UPPER(TRIM(word8))==UPPER(TRIM(noppup_ac(M.ibar)))
       IF FOUND()
          REPLACE problem with .T.
          REPLACE comment with  ;
                  'The popup activated by this command is not defined.'
       ENDIF
    ENDFOR
    SET FILTER to
    GOTO top
 ENDIF
 SELECT (M.workarea)
 SET FILTER to TRIM(word1)=='ON' .and. LEFT(word2, 4)=='SELE' .and. TRIM(word3)=='MENU' .and. UPPER(TRIM(word4))=='_MSYSMENU' .and.  .not. problem .and. curmenu
 GOTO top
 COUNT to M.onmenu
 IF M.onmenu>0
    GOTO bottom
    wtext = resttxt
    wtext = ALLTRIM(M.wtext)
    procname = ''
    IF UPPER(SUBSTR(M.wtext, 1, 3))=='DO ' .and. LEN(M.wtext)>3
       procname = ALLTRIM(SUBSTR(M.wtext, 4))
       IF AT(' WITH ', M.procname)>0
          procname = ''
       ELSE
          IF AT(' ', M.procname)>1
             procname = ALLTRIM(SUBSTR(M.procname, 1, AT(' ', M.procname)))
          ENDIF
       ENDIF
    ENDIF
    xrec = RECNO()
    SET FILTER to
    GOTO top
    takeproc = .F.
    IF LEN(M.procname)>0
       LOCATE for TRIM(word1)=='PROC' .and. UPPER(TRIM(word2))== ;
              UPPER(M.procname)
       IF FOUND()
          takeproc = .T.
       ENDIF
    ENDIF
    IF  .not. M.takeproc
       GOTO M.xrec
    ENDIF
    SELECT (M.outarea)
    GOTO top
    LOCATE for objtype=1
    IF FOUND()
       IF M.takeproc
          REPLACE procedure with workfile.resttxt
       ELSE
          REPLACE procedure with M.wtext
       ENDIF
    ENDIF
 ENDIF
 SELECT (M.workarea)
 SET FILTER to
 SELECT (M.workarea)
 SET FILTER to TRIM(word1)=='ON' .and. LEFT(word2, 4)=='SELE' .and. LEFT(word3, 4)=='POPU' .and. UPPER(TRIM(word4))=='ALL' .and.  .not. problem .and. curmenu
 GOTO top
 COUNT to M.onmenu
 IF M.onmenu>0
    GOTO bottom
    wtext = resttxt
    wtext = ALLTRIM(M.wtext)
    procname = ''
    IF UPPER(SUBSTR(M.wtext, 1, 3))=='DO ' .and. LEN(M.wtext)>3
       procname = ALLTRIM(SUBSTR(M.wtext, 4))
       IF AT(' WITH ', M.procname)>0
          procname = ''
       ELSE
          IF AT(' ', M.procname)>1
             procname = ALLTRIM(SUBSTR(M.procname, 1, AT(' ', M.procname)))
          ENDIF
       ENDIF
    ENDIF
    xrec = RECNO()
    SET FILTER to
    GOTO top
    takeproc = .F.
    IF LEN(M.procname)>0
       LOCATE for TRIM(word1)=='PROC' .and. UPPER(TRIM(word2))== ;
              UPPER(M.procname)
       IF FOUND()
          takeproc = .T.
       ENDIF
    ENDIF
    IF  .not. M.takeproc
       GOTO M.xrec
    ENDIF
    SELECT (M.outarea)
    GOTO top
    LOCATE for objtype=2 .and. objcode=1
    IF FOUND()
       IF M.takeproc
          REPLACE procedure with workfile.resttxt
       ELSE
          REPLACE procedure with M.wtext
       ENDIF
    ENDIF
 ENDIF
 SELECT (M.workarea)
 SET FILTER to
 SELECT (M.workarea)
 SET FILTER to TRIM(word1)=='ON' .and. LEFT(word2, 4)=='SELE' .and. LEFT(word3, 4)=='POPU' .and. UPPER(TRIM(word4))<>'ALL' .and.  .not. problem .and. curmenu
 GOTO top
 SELECT (M.outarea)
 SET FILTER to
 GOTO top
 SELECT (M.workarea)
 SCAN
    wtext = resttxt
    wtext = ALLTRIM(M.wtext)
    wpopup = TRIM(word4)
    procname = ''
    IF UPPER(SUBSTR(M.wtext, 1, 3))=='DO ' .and. LEN(M.wtext)>3
       procname = ALLTRIM(SUBSTR(M.wtext, 4))
       IF AT(' WITH ', M.procname)>0
          procname = ''
       ELSE
          IF AT(' ', M.procname)>1
             procname = ALLTRIM(SUBSTR(M.procname, 1, AT(' ', M.procname)))
          ENDIF
       ENDIF
    ENDIF
    takeproc = .F.
    xrec = RECNO()
    SET FILTER to
    GOTO top
    IF LEN(M.procname)>0
       LOCATE for TRIM(word1)=='PROC' .and. UPPER(TRIM(word2))== ;
              UPPER(M.procname)
       IF FOUND()
          takeproc = .T.
       ENDIF
    ENDIF
    IF LEN(M.wtext)>0 .and. LEN(M.wpopup)>0
       SELECT (M.outarea)
       GOTO top
       LOCATE for objtype=2 .and. UPPER(ALLTRIM(levelname))==UPPER(M.wpopup)
       IF FOUND()
          IF M.takeproc
             REPLACE procedure with workfile.resttxt
          ELSE
             REPLACE procedure with M.wtext
          ENDIF
       ENDIF
       SELECT (M.workarea)
    ENDIF
    SET FILTER to TRIM(word1)=='ON' .and. LEFT(word2, 4)=='SELE' .and. LEFT(word3, 4)=='POPU' .and. UPPER(TRIM(word4))<>'ALL' .and.  .not. problem .and. curmenu
    GOTO M.xrec
 ENDSCAN
 SET FILTER to
 SELECT (M.outarea)
 SET FILTER to
 DO onsele with 'PAD'
 DO onsele with 'BAR'
 SELECT (M.outarea)
 SET FILTER to
 pack_need = .F.
 SCAN
    IF objtype=3 .and. objcode=77
       i_convert = .F.
       SKIP
       IF EOF()
          i_convert = .T.
       ELSE
          IF objtype=2 .and. objcode=0 .and. numitems=0
             i_convert = .T.
             DELETE
             pack_need = .T.
             SKIP -1
          ENDIF
       ENDIF
       IF M.i_convert
          REPLACE objcode with 78
       ENDIF
    ENDIF
 ENDSCAN
 IF M.pack_need
    PACK
 ENDIF
 IF  .not. M.generated
    SELECT (M.workarea)
    fil_s_mar = 'TRIM(word1)=="SET" .AND. trim(word2)=="MARK" .AND. '+ ;
                'trim(word3)=="OF" .AND. UPPER(left(word4,4))=="POPU" .AND. .not.problem .and. curmenu'
    SET FILTER TO &fil_s_mar
    GOTO top
    SELECT (M.outarea)
    SET FILTER to
    GOTO top
    SELECT (M.workarea)
    SCAN
       pop_name = TRIM(word5)
       pop_mark = TRIM(word7)
       IF LEN(M.pop_mark)=0
          LOOP
       ELSE
          pop_mark = &pop_mark
       ENDIF
       xrec = RECNO()
       SET FILTER TO &fil_d_ppu
       GOTO top
       LOCATE for TRIM(UPPER(word3))==UPPER(M.pop_name)
       xrec_d = 0
       IF FOUND()
          xrec_d = RECNO()
       ENDIF
       IF M.xrec_d=0 .or. M.xrec_d>M.xrec
          SET FILTER TO &fil_s_mar
          GOTO M.xrec
          LOOP
       ENDIF
       SELECT (M.outarea)
       GOTO top
       LOCATE for TRIM(UPPER(levelname))<>'_MSYSMENU' .and. objtype=2  ;
              .and. TRIM(UPPER(name))==UPPER(M.pop_name) .and. numitems>0
       IF FOUND()
          REPLACE mark with M.pop_mark
       ENDIF
       SELECT (M.workarea)
       SET FILTER TO &fil_s_mar
       GOTO M.xrec
    ENDSCAN
    SET FILTER to
    SELECT (M.outarea)
 ENDIF
 IF  .not. M.generated
    SELECT (M.workarea)
    fil_s_mar = 'TRIM(word1)=="SET" .AND. trim(word2)=="MARK" .AND. '+ ;
                'trim(word3)=="OF" .AND. UPPER(trim(word4))=="BAR" .AND. .not.problem .and. curmenu'
    SET FILTER TO &fil_s_mar
    GOTO top
    SELECT (M.outarea)
    SET FILTER to
    GOTO top
    SELECT (M.workarea)
    SCAN
       bar_name = TRIM(word5)
       pop_name = TRIM(word7)
       bar_mark = TRIM(word9)
       IF LEN(M.bar_mark)=0
          LOOP
       ELSE
          bar_mark = &bar_mark
       ENDIF
       xrec = RECNO()
       SET FILTER TO &fil_d_bar
       GOTO top
       LOCATE for TRIM(UPPER(word3))==UPPER(M.bar_name) .and.  ;
              TRIM(UPPER(word5))==UPPER(M.pop_name)
       xrec_d = 0
       IF FOUND()
          xrec_d = RECNO()
       ENDIF
       IF M.xrec_d=0 .or. M.xrec_d>M.xrec
          SET FILTER TO &fil_s_mar
          GOTO M.xrec
          LOOP
       ENDIF
       SELECT (M.outarea)
       GOTO top
       LOCATE for TRIM(UPPER(levelname))==UPPER(pop_name) .and. objtype=3  ;
              .and. TRIM(UPPER(name))==UPPER(M.bar_name)
       IF FOUND()
          REPLACE mark with M.bar_mark
       ENDIF
       SELECT (M.workarea)
       SET FILTER TO &fil_s_mar
       GOTO M.xrec
    ENDSCAN
    SET FILTER to
    SELECT (M.outarea)
 ENDIF
 RETURN

PROCEDURE creappup
 PARAMETER inum
 PRIVATE main_name, sub_name, defibars
 PRIVATE yprompt, ymessage, ymark, ykey, ycolor, ybefore, yafter, yskip
 main_name = npads(M.inum)
 sub_name = npopups(M.inum)
 SELECT (M.outarea)
 APPEND blank
 REPLACE objtype with 3
 REPLACE objcode with 77
 REPLACE name with M.main_name
 REPLACE levelname with '_msysmenu'
 REPLACE itemnum with STR(M.inum, 3)
 SELECT (M.workarea)
 SET FILTER TO &fil_d_pad
 GOTO top
 LOCATE for UPPER(TRIM(word3))==UPPER(TRIM(M.main_name))
 yprompt = ''
 ymessage = ''
 ymark = M.set_mark
 ykey = ''
 ycolor = M.set_color4
 IF FOUND()
    yprompt = xprompt
    ymessage = xmessage
    ykey = xkey
    yskip = xskip
    ybefore = xbefore
    yafter = xafter
    yprompt = ALLTRIM(M.yprompt)
    ymessage = ALLTRIM(M.ymessage)
    ykey = ALLTRIM(M.ykey)
    yskip = ALLTRIM(M.yskip)
    ybefore = ALLTRIM(M.ybefore)
    yafter = ALLTRIM(M.yafter)
    yprompt = IIF(LEN(M.yprompt)<9, '', SUBSTR(M.yprompt, 9))
    yprompt = LEFT(M.yprompt, LEN(M.yprompt)-1)
    ymessage = IIF(LEN(M.ymessage)<9, '', SUBSTR(M.ymessage, 9))
    ykey = IIF(LEN(M.ykey)<5, '', SUBSTR(M.ykey, 5))
    yskip = IIF(LEN(M.yskip)<9, '', SUBSTR(M.yskip, 9))
    ybefore = IIF(LEN(M.ybefore)<7, '', SUBSTR(M.ybefore, 7))
    yafter = IIF(LEN(M.yafter)<6, '', SUBSTR(M.yafter, 6))
    SELECT (M.outarea)
    REPLACE prompt with M.yprompt
    IF M.outvers<>'20'
       REPLACE message with M.ymessage
    ENDIF
    REPLACE mark with M.ymark
    REPLACE skipfor with M.yskip
    DO keychck with M.ykey
 ENDIF
 SELECT (M.workarea)
 SET FILTER TO &fil_d_ppu
 GOTO top
 LOCATE for UPPER(TRIM(word3))==UPPER(TRIM(M.sub_name))
 ymark = M.set_mark
 ykey = ''
 ycolor = M.set_color4
 IF FOUND()
    ymark = xmark
    ykey = xkey
    ycolor = xcolor
    ymark = ALLTRIM(M.ymark)
    ykey = ALLTRIM(M.ykey)
    ycolor = ALLTRIM(M.ycolor)
    ymark = IIF(LEN(M.ymark)<6, '', SUBSTR(M.ymark, 6))
    ykey = IIF(LEN(M.ykey)<6, '', SUBSTR(M.ykey, 6))
    ycolor = IIF(LEN(M.ycolor)<13, '', SUBSTR(M.ycolor, 13))
 ENDIF
 IF LEN(TRIM(M.ymark))=0
    ymark = M.set_mark
 ENDIF
 SELECT (M.outarea)
 APPEND blank
 REPLACE objtype with 2
 REPLACE objcode with 0
 REPLACE name with M.sub_name
 REPLACE levelname with M.sub_name
 REPLACE itemnum with '  0'
 REPLACE proctype with 1
 REPLACE namechange with .F.
 REPLACE mark with M.ymark
 IF LEN(TRIM(M.ycolor))>0
    REPLACE scheme with VAL(M.ycolor)
 ENDIF
 IF FOUND()
    DO keychck with M.ykey
 ENDIF
 defibars = 0
 FOR ii = 1 to M.defppu
    IF UPPER(TRIM(def_ppups(M.ii)))==UPPER(TRIM(M.sub_name))
       defibars = npop_bar(M.ii)
       def_pp_ini( M.ii) = .T.
       EXIT
    ENDIF
 ENDFOR
 REPLACE numitems with M.defibars
 RETURN

PROCEDURE inseppup
 PARAMETER inum
 PRIVATE main_name, sub_name
 PRIVATE yprompt, ymessage, ymark, ykey, ycolor, ybefore, yafter, yskip
 PRIVATE defibars, ii1, xlevel
 main_name = nobar(M.inum)
 xlevel = noppup(M.inum)
 sub_name = noppup_ac(M.inum)
 SELECT (M.outarea)
 REPLACE objtype with 3
 REPLACE objcode with 77
 REPLACE name with M.main_name
 REPLACE levelname with M.xlevel
 SELECT (M.workarea)
 SET FILTER TO &fil_d_ppu
 GOTO top
 LOCATE for UPPER(TRIM(word3))==UPPER(TRIM(M.sub_name))
 yprompt = ''
 ymessage = ''
 ymark = M.set_mark
 ykey = ''
 ycolor = M.set_color4
 IF FOUND()
    yprompt = xprompt
    ymessage = xmessage
    ymark = xmark
    ykey = xkey
    yskip = xskip
    ybefore = xbefore
    yafter = xafter
    ycolor = xcolor
    yprompt = ALLTRIM(M.yprompt)
    ymessage = ALLTRIM(M.ymessage)
    ymark = ALLTRIM(M.ymark)
    ykey = ALLTRIM(M.ykey)
    yskip = ALLTRIM(M.yskip)
    ybefore = ALLTRIM(M.ybefore)
    yafter = ALLTRIM(M.yafter)
    ycolor = ALLTRIM(M.ycolor)
    yprompt = IIF(LEN(M.yprompt)<9, '', SUBSTR(M.yprompt, 9))
    yprompt = LEFT(M.yprompt, LEN(M.yprompt)-1)
    ymessage = IIF(LEN(M.ymessage)<9, '', SUBSTR(M.ymessage, 9))
    ymark = IIF(LEN(M.ymark)<6, '', SUBSTR(M.ymark, 6))
    ykey = IIF(LEN(M.ykey)<5, '', SUBSTR(M.ykey, 5))
    yskip = IIF(LEN(M.yskip)<9, '', SUBSTR(M.yskip, 9))
    ybefore = IIF(LEN(M.ybefore)<7, '', SUBSTR(M.ybefore, 7))
    yafter = IIF(LEN(M.yafter)<6, '', SUBSTR(M.yafter, 6))
    ycolor = IIF(LEN(M.ycolor)<13, '', SUBSTR(M.ycolor, 13))
    SELECT (M.outarea)
    IF M.outvers<>'20'
       REPLACE message with M.ymessage
    ENDIF
    IF LEN(TRIM(M.ymark))=0
       ymark = M.set_mark
    ENDIF
    REPLACE mark with M.ymark
    DO keychck with M.ykey
 ELSE
    SET FILTER TO &fil_o_bar
    GOTO top
    LOCATE for UPPER(TRIM(word3))==UPPER(TRIM(M.main_name)) .and.  ;
           UPPER(TRIM(word5))==UPPER(TRIM(M.xlevel)) .and.  ;
           UPPER(TRIM(word8))==UPPER(TRIM(M.sub_name))
    IF FOUND()
       REPLACE problem with .T.
       REPLACE comment with 'Popup '+M.sub_name+' is not defined.'
    ENDIF
 ENDIF
 SELECT (M.outarea)
 INSERT blank
 REPLACE objtype with 2
 REPLACE objcode with 0
 REPLACE name with M.sub_name
 REPLACE levelname with M.sub_name
 REPLACE itemnum with '  0'
 REPLACE proctype with 1
 REPLACE mark with M.ymark
 REPLACE namechange with .F.
 DO keychck with M.ykey
 IF LEN(TRIM(M.ycolor))>0
    REPLACE scheme with VAL(M.ycolor)
 ENDIF
 defibars = 0
 FOR ii1 = 1 to M.defppu
    IF UPPER(TRIM(def_ppups(M.ii1)))==UPPER(TRIM(M.sub_name))
       defibars = npop_bar(M.ii1)
       def_pp_ini( M.ii1) = .T.
       EXIT
    ENDIF
 ENDFOR
 REPLACE numitems with M.defibars
 RETURN

PROCEDURE creabars
 PARAMETER inum, i_crea
 PRIVATE ii, fil_d_b
 PRIVATE yprompt, ymessage, yskip, ymark, ykey, yname, ylevel
 SELECT (M.workarea)
 IF M.i_crea
    fil_d_b = 'TRIM(word1)=="DEFI" .AND. TRIM(word2)=="BAR" .AND. '+ ;
              'UPPER(TRIM(word5))==UPPER(TRIM(npopups(m.inum))) .and. .not.problem .and. curmenu'
 ELSE
    fil_d_b = 'TRIM(word1)=="DEFI" .AND. TRIM(word2)=="BAR" .AND. '+ ;
              'UPPER(TRIM(word5))==UPPER(TRIM(noppup_ac(m.inum))) .and. .not.problem .and. curmenu'
 ENDIF
 SET FILTER TO &fil_d_b
 GOTO top
 ii = 1
 DO while  .not. EOF()
    yprompt = xprompt
    ymessage = xmessage
    yskip = xskip
    ymark = xmark
    ykey = xkey
    yname = TRIM(word3)
    ylevel = TRIM(word5)
    yprompt = ALLTRIM(M.yprompt)
    ymessage = ALLTRIM(M.ymessage)
    yskip = ALLTRIM(M.yskip)
    ymark = ALLTRIM(M.ymark)
    ykey = ALLTRIM(M.ykey)
    yprompt = IIF(LEN(M.yprompt)<9, '', SUBSTR(M.yprompt, 9))
    yprompt = LEFT(yprompt, LEN(yprompt)-1)
    ymessage = IIF(LEN(M.ymessage)<9, '', SUBSTR(M.ymessage, 9))
    yskip = IIF(LEN(M.yskip)<10, '', SUBSTR(M.yskip, 10))
    ymark = IIF(LEN(M.ymark)<6, '', SUBSTR(M.ymark, 6))
    ykey = IIF(LEN(M.ykey)<5, '', SUBSTR(M.ykey, 5))
    SELECT (M.outarea)
    IF M.i_crea
       APPEND blank
    ELSE
       INSERT blank
    ENDIF
    REPLACE objtype with 3
    REPLACE objcode with 78
    REPLACE name with M.yname
    REPLACE levelname with M.ylevel
    REPLACE itemnum with STR(M.ii, 3)
    REPLACE prompt with M.yprompt
    IF M.outvers<>'20'
       REPLACE message with M.ymessage
    ENDIF
    REPLACE skipfor with M.yskip
    REPLACE mark with M.ymark
    DO keychck with M.ykey
    ii = M.ii+1
    SELECT (M.workarea)
    SKIP
 ENDDO
 SET FILTER to
 GOTO top
 RETURN

PROCEDURE keychck
 PARAMETER ykey
 IF LEN(M.ykey)=0
    RETURN
 ENDIF
 IF AT(',', M.ykey)>0
    REPLACE keyname with LEFT(M.ykey, AT(',', M.ykey)-1)
    REPLACE keylabel with ALLTRIM(SUBSTR(M.ykey, AT(',', M.ykey)+1))
    IF LEN(keylabel)>1
       IF INLIST(LEFT(keylabel, 1), '"', "'", '[')
          REPLACE keylabel with SUBSTR(keylabel, 2, LEN(keylabel)-2)
       ENDIF
    ENDIF
 ELSE
    REPLACE keyname with M.ykey
 ENDIF

PROCEDURE onsele
 PARAMETER which
 PRIVATE pack_need, fil_o_sel, which, pbname, ofmenu, xrecno, pname
 SELECT (M.workarea)
 IF M.which='PAD'
    fil_o_sel = 'trim(word1)=="ON" .and. left(word2,4)=="SELE" .and. trim(word3)=="PAD"'+ ;
                ' .and. trim(word5)=="OF" .and. upper(trim(word6))=="_MSYSMENU" .and. .not.problem .and. curmenu'
 ELSE
    fil_o_sel = 'trim(word1)=="ON" .and. left(word2,4)=="SELE" .and. trim(word3)=="BAR"'+ ;
                ' .and. trim(word5)=="OF" .and. .not.problem .and. curmenu'
 ENDIF
 pack_need = .F.
 SET FILTER TO &fil_o_sel
 SCAN
    wtext = resttxt
    pbname = TRIM(UPPER(word4))
    ofmenu = ALLTRIM(UPPER(word6))
    IF LEN(M.wtext)=0
       LOOP
    ENDIF
    SELECT (M.outarea)
    GOTO top
    IF M.which='PAD'
       LOCATE for objtype=3 .and. TRIM(UPPER(levelname))=='_MSYSMENU'  ;
              .and. TRIM(UPPER(name))==M.pbname
    ELSE
       LOCATE for objtype=3 .and. TRIM(UPPER(levelname))==M.ofmenu .and.  ;
              TRIM(UPPER(name))==M.pbname
    ENDIF
    IF EOF()
       SELECT (M.workarea)
       REPL comment WITH "This command is not applicated "+  "because this &which is not defined."
       LOOP
    ENDIF
    IF numitems<>0
       SELECT (M.workarea)
       REPL comment WITH "This command is not applicated "+  "because a popup is activated from this &which."
       LOOP
    ENDIF
    IF M.which=='BAR' .and. objcode=77
       SELECT (M.workarea)
       REPLACE comment with 'ON BAR .. command is present - '+ ;
               ' the ON SELE BAR .. cannot be coded.'
       LOOP
    ENDIF
    REPLACE command with M.wtext
    REPLACE objcode with 67
    xrecno = RECNO()
    SKIP
    IF  .not. EOF() .and. objtype=2
       DELETE
       pack_need = .T.
    ENDIF
    GOTO M.xrecno
    IF UPPER(LEFT(M.wtext, 3))=='DO '
       wtext = SUBSTR(M.wtext, 4)
       IF AT(' WITH ', UPPER(M.wtext))>0
          SELECT (M.workarea)
          LOOP
       ENDIF
       pname = ''
       IF AT(' ', M.wtext)>1
          pname = ALLTRIM(SUBSTR(M.wtext, 1, AT(' ', M.wtext)))
       ENDIF
       IF LEN(M.pname)=0
          SELECT (M.workarea)
          LOOP
       ENDIF
       SELECT (M.workarea)
       xrecno = RECNO()
       SET FILTER to TRIM(UPPER(word1))=='PROC'
       GOTO top
       LOCATE for ALLTRIM(UPPER(word2))==UPPER(M.pname)
       IF FOUND()
          SELECT (M.outarea)
          REPLACE proctype with 3
          REPLACE objcode with 80
          REPLACE procedure with workfile.resttxt
          REPLACE command with ''
          SELECT (M.workarea)
       ELSE
          SELECT (M.workarea)
       ENDIF
       SET FILTER TO &fil_o_sel
       GOTO M.xrecno
    ENDIF
 ENDSCAN
 SET FILTER to
 GOTO top
 SELECT (M.outarea)
 IF M.pack_need
    PACK
 ENDIF
 RETURN

PROCEDURE test_bef
 PRIVATE ybefore, xbef_txt0, xbef_txt
 PRIVATE yafter, xaft_txt0, xaft_txt, xpad_prev
 SELECT (M.workarea)
 SET FILTER TO &fil_d_pad
 GOTO top
 ybefore = xbefore
 IF LEN(ALLTRIM(M.ybefore))>7
    xbef_txt0 = UPPER(SUBSTR(ALLTRIM(M.ybefore), 8))
    l_before = .T.
    SCAN
       ybefore = xbefore
       IF LEN(ALLTRIM(M.ybefore))>7
          xbef_txt = UPPER(SUBSTR(ALLTRIM(M.ybefore), 8))
          IF xbef_txt==M.xbef_txt0
          ELSE
             l_before = .F.
             EXIT
          ENDIF
       ELSE
          l_before = .F.
          EXIT
       ENDIF
    ENDSCAN
 ENDIF
 IF M.l_before
    w_befaft = M.xbef_txt0
 ELSE
    GOTO top
    yafter = xafter
    IF LEN(ALLTRIM(M.yafter))>6
       xaft_txt0 = UPPER(SUBSTR(ALLTRIM(M.yafter), 7))
       xpad_prev = UPPER(ALLTRIM(word3))
       l_after = .T.
       SKIP
       DO while  .not. EOF()
          yafter = xafter
          IF LEN(ALLTRIM(M.yafter))>6
             xaft_txt = UPPER(SUBSTR(ALLTRIM(M.yafter), 7))
             IF xaft_txt==M.xpad_prev
                xpad_prev = UPPER(ALLTRIM(word3))
             ELSE
                l_after = .F.
                EXIT
             ENDIF
          ELSE
             l_after = .F.
             EXIT
          ENDIF
          SKIP
       ENDDO
    ENDIF
    IF M.l_after
       w_befaft = M.xaft_txt0
    ENDIF
 ENDIF
 SET FILTER to
 GOTO top
 SELECT (M.outarea)
 RETURN

PROCEDURE multinam
 PARAMETER tempfile, outfi_a, outfi_b
 PRIVATE name_len, last_dot, ii, truelen, chr
 tempfile = TRIM(M.tempfile)
 name_len = LEN(M.tempfile)
 IF M.name_len=0
    RETURN
 ENDIF
 IF AT('.', M.tempfile)=0
    outfi_a = M.tempfile
    outfi_b = ''
 ELSE
    last_dot = AT('.', M.tempfile, OCCURS('.', M.tempfile))
    outfi_a = ALLTRIM(SUBSTR(M.tempfile, 1, M.last_dot-1))
    outfi_b = ALLTRIM(SUBSTR(M.tempfile, M.last_dot))
 ENDIF
 ii = LEN(M.outfi_a)
 IF M.ii>6
    truelen = 0
    DO while .T.
       chr = SUBSTR(M.outfi_a, M.ii, 1)
       IF ISALPHA(M.chr) .or. ISDIGIT(M.chr) .or. INLIST(M.chr, '_', '^', '$', '~', '!', '#', '%', '&', '-', '{', '}', '(', ')', '@', "'")
          ii = ii-1
          truelen = M.truelen+1
       ELSE
          EXIT
       ENDIF
       IF M.ii=0 .or. M.truelen=8
          EXIT
       ENDIF
    ENDDO
    DO case
       CASE M.truelen=8
          outfi_a = SUBSTR(M.outfi_a, 1, LEN(M.outfi_a)-2)
       CASE M.truelen=7
          outfi_a = SUBSTR(M.outfi_a, 1, LEN(M.outfi_a)-1)
    ENDCASE
 ENDIF
 RETURN

PROCEDURE getsetup
 PARAMETER line
 PRIVATE oldline, incl_empt, incl_line, endcode
 oldline = ''
 incl_empt = .F.
 endcode = getline2(M.line)
 DO while  .not. M.endcode
    IF LEN(M.line)=0 .or. iscomment(M.line)
       IF M.incl_comm
          IF LEN(M.line)=0
             incl_line = incl_empt
          ELSE
             IF LEN(M.line)<9
                IF LEN(ALLTRIM(M.line))=1 .and. ALLTRIM(M.line)=='*'
                   IF LEN(M.oldline)>=9 .and. SUBSTR(M.oldline, 1, 9)== ;
                      '*       *'
                      incl_line = .F.
                      incl_empt = .F.
                   ELSE
                      incl_line = .T.
                      incl_empt = .T.
                   ENDIF
                ELSE
                   incl_line = .T.
                   incl_empt = .T.
                ENDIF
             ELSE
                IF SUBSTR(M.line, 1, 9)=='*       *'
                   incl_line = .F.
                   incl_empt = .F.
                ELSE
                   incl_line = .T.
                   incl_empt = .T.
                ENDIF
             ENDIF
          ENDIF
          IF M.incl_line
             REPLACE setup with setup+M.line+CHR(13)+CHR(10)
          ENDIF
       ENDIF
    ELSE
       IF ismenusect(M.line)
          EXIT
       ENDIF
       incl_empt = .T.
       REPLACE setup with setup+M.line+CHR(13)+CHR(10)
    ENDIF
    oldline = M.line
    endcode = getline2(M.line)
 ENDDO
 RETURN

PROCEDURE getcleanup
 PARAMETER line
 PRIVATE oldline, incl_empt, incl_line
 oldline = ''
 incl_empt = .F.
 DO while  .not. M.endcode
    IF LEN(M.line)=0 .or. iscomment(M.line)
       IF M.incl_comm
          IF LEN(M.line)=0
             incl_line = incl_empt
          ELSE
             IF LEN(M.line)<9
                IF LEN(ALLTRIM(M.line))=1 .and. ALLTRIM(M.line)=='*'
                   IF LEN(M.oldline)>=9 .and. SUBSTR(M.oldline, 1, 9)== ;
                      '*       *'
                      incl_line = .F.
                      incl_empt = .F.
                   ELSE
                      incl_line = .T.
                      incl_empt = .T.
                   ENDIF
                ELSE
                   incl_line = .T.
                   incl_empt = .T.
                ENDIF
             ELSE
                IF SUBSTR(M.line, 1, 9)=='*       *'
                   incl_line = .F.
                   incl_empt = .F.
                ELSE
                   incl_line = .T.
                   incl_empt = .T.
                ENDIF
             ENDIF
          ENDIF
          IF M.incl_line
             REPLACE cleanup with cleanup+M.line+CHR(13)+CHR(10)
          ENDIF
       ENDIF
    ELSE
       IF UPPER(LEFT(ALLTRIM(M.line), 4))=='PROC'
          EXIT
       ENDIF
       incl_empt = .T.
       REPLACE cleanup with cleanup+M.line+CHR(13)+CHR(10)
    ENDIF
    oldline = M.line
    endcode = getline2(M.line)
 ENDDO
 RETURN

PROCEDURE erreport
 PRIVATE nlines, wrt_title
 SELECT (M.workarea)
 SET FILTER to problem
 COUNT to nlines
 IF M.nlines=0
    RETURN
 ENDIF
 SET ALTERNATE to
 SET ALTERNATE off
 IF FILE(M.outfile+'.err')
    SET ALTERNATE to (M.outfile+'.err') additive
 ELSE
    SET ALTERNATE to (M.outfile+'.err')
 ENDIF
 SET ALTERNATE on
 SET CONSOLE off
 ?
 SET FILTER to problem .and. curmenu .and. MEMLINES(comment)>0
 GOTO top
 wrt_title = .T.
 SCAN
    IF M.wrt_title
       wrt_title = .F.
       ? 'The following commands were not processed in menu '+ ;
       UPPER(M.menu_name)+':'
       ?
       ? '    Line  Command / Message'
       ? '-------------------------------------------------------------'
    ENDIF
    ? STR(line, 8)+'  '
    IF LEN(ALLTRIM(text))<=70
       ?? ALLTRIM(text)
    ELSE
       ?? SUBSTR(ALLTRIM(text), 1, 67)+' ..'
    ENDIF
    ? SPACE(10)+ALLTRIM(comment)
 ENDSCAN
 IF  .not. M.wrt_title
    ?
    ?
 ENDIF
 SELECT (M.workarea)
 SET FILTER to problem .and. curmenu .and. MEMLINES(comment)=0
 GOTO top
 wrt_title = .T.
 SCAN
    IF M.wrt_title
       wrt_title = .F.
       ? 'The following commands are not correct FoxPro commands:'
       ?
       ? '    Line  Command '
       ? '-------------------------------------------------------------'
    ENDIF
    ? STR(line, 8)+'  '
    IF LEN(ALLTRIM(text))<=70
       ?? ALLTRIM(text)
    ELSE
       ?? SUBSTR(ALLTRIM(text), 1, 67)+' ..'
    ENDIF
 ENDSCAN
 IF  .not. M.wrt_title
    ?
    ?
 ENDIF
 SET ALTERNATE off
 SET ALTERNATE to
 SET CONSOLE on
 RETURN

PROCEDURE onemenu
 SELECT (M.workarea)
 SET FILTER to
 GOTO top
 SCAN
    REPLACE curmenu with .T.
    REPLACE delrec with .T.
 ENDSCAN
 GOTO top
 DO generdb
 DO erreport
 RETURN

PROCEDURE moremenu
 PRIVATE new_elem, ii, ipos, tofile
 SELECT (M.outarea)
 REPLACE setup with ''
 REPLACE cleanup with ''
 menu_name = ''
 menu_names( 1) = ''
 cnt_menus = 0
 SELECT (M.workarea)
 SET FILTER to TRIM(word1)=='DEFI' .and. TRIM(word2)=='PAD' .and. LEN(TRIM(word5))>0 .and.  .not. problem
 GOTO top
 IF EOF()
    RETURN
 ENDIF
 menu_name = UPPER(TRIM(word5))
 menu_names( 1) = M.menu_name
 cnt_menus = 1
 SCAN
    menu_name = UPPER(TRIM(word5))
    ipos = ASCAN(menu_names, M.menu_name)
    IF M.ipos=0
       cnt_menus = M.cnt_menus+1
       DIMENSION menu_names( M.cnt_menus)
       IF M.menu_name=='_MSYSMENU'
          menu_names( M.cnt_menus) = menu_names(1)
          menu_names( 1) = '_MSYSMENU'
       ELSE
          menu_names( M.cnt_menus) = M.menu_name
       ENDIF
    ENDIF
 ENDSCAN
 IF M.cnt_menus>99
    WAIT window 'Too many menus - only first 99 menus will be generated.'
    cnt_menus = 99
 ENDIF
 SET FILTER to
 REPLACE curmenu with .F., delrec with (.F.)
 SET FILTER to TRIM(word1)=='SET' .and. LEFT(word2, 4)=='SYSM'
 REPLACE curmenu with (.T.)
 SET FILTER to TRIM(word1)=='ON' .and. LEFT(word2, 4)=='SELE' .and. UPPER(LEFT(word3, 4))=='POPU' .and. TRIM(UPPER(word4))=='ALL'
 REPLACE curmenu with (.T.)
 SET FILTER to
 FOR ii = 1 to M.cnt_menus
    menu_name = menu_names(M.ii)
    DO markmenu
    SELECT (M.outarea)
    REPLACE setup with '*  The original name of this menu was: '+ ;
            UPPER(M.menu_name)+CHR(13)+CHR(10)
    DO generdb
    DO erreport
    SELECT (M.outarea)
    tofile = M.outfi_a+CHRTRAN(STR(M.ii, 2), ' ', '0')+M.outfi_b
    COPY to (M.tofile)
    DELETE all
    PACK
    IF M.ii<M.cnt_menus
       APPEND blank
    ENDIF
    SELECT (M.workarea)
    SET FILTER to
    DELETE all for delrec
    PACK
 ENDFOR
 RETURN

PROCEDURE markmenu
 PRIVATE nppups, np_nxt, ip, ppup
 SELECT (M.workarea)
 SET FILTER to TRIM(word1)=='SET' .and. TRIM(word2)=='MARK' .and. TRIM(word4)=='MENU' .and. TRIM(UPPER(word5))==M.menu_name
 REPLACE curmenu with .T., delrec with .T., word5 with ('_MSYSMENU')
 SET FILTER to TRIM(word1)=='ON' .and. LEFT(word2, 4)=='SELE' .and. TRIM(word3)=='MENU' .and. TRIM(UPPER(word4))==M.menu_name
 REPLACE curmenu with .T., delrec with .T., word4 with ('_MSYSMENU')
 SET FILTER to TRIM(word1)=='DEFI' .and. TRIM(word2)=='PAD' .and. TRIM(UPPER(word5))==M.menu_name
 REPLACE curmenu with .T., delrec with .T., word5 with ('_MSYSMENU')
 SET FILTER to TRIM(word1)=='ON' .and. LEFT(word2, 4)=='SELE' .and. TRIM(UPPER(word3))=='PAD' .and. TRIM(UPPER(word6))==M.menu_name
 REPLACE curmenu with .T., delrec with .T., word6 with ('_MSYSMENU')
 SET FILTER to TRIM(word1)=='SET' .and. TRIM(word2)=='MARK' .and. TRIM(UPPER(word4))=='PAD' .and. TRIM(UPPER(word7))==M.menu_name
 REPLACE curmenu with .T., delrec with .T., word7 with ('_MSYSMENU')
 SET FILTER to TRIM(word1)=='ON' .and. TRIM(word2)=='PAD' .and. UPPER(TRIM(word5))==M.menu_name .and. (UPPER(LEFT(word6, 4))=='ACTI'  or UPPER(LEFT(word6, 3))=='PAD' ).and. UPPER(LEFT(word7, 4))=='POPU'
 REPLACE curmenu with .T., delrec with .T., word5 with ('_MSYSMENU')
 GOTO top
 SET FILTER to TRIM(word1)=='ON' .and. TRIM(word2)=='PAD' .and. UPPER(TRIM(word5))=='_MSYSMENU' .and. (UPPER(LEFT(word6, 4))=='ACTI' or UPPER(LEFT(word6, 3))=='PAD') .and. UPPER(LEFT(word7, 4))=='POPU'
 DIMENSION ppups( 1)
 nppups = 0
 SCAN
    IF problem .or. LEN(TRIM(word8))=0
       LOOP
    ENDIF
    nppups = M.nppups+1
    DIMENSION ppups( M.nppups)
    ppups( M.nppups) = UPPER(TRIM(word8))
 ENDSCAN
 DO while .T.
    DIMENSION pp_nxt( 1)
    np_nxt = 0
    FOR ip = 1 to M.nppups
       ppup = ppups(M.ip)
       SET FILTER to TRIM(word1)=='DEFI' .and. LEFT(word2, 4)=='POPU' .and. TRIM(UPPER(word3))==M.ppup
       REPLACE curmenu with .T., delrec with (.T.)
       SET FILTER to TRIM(word1)=='DEFI' .and. TRIM(word2)=='BAR' .and. TRIM(UPPER(word5))==M.ppup
       REPLACE curmenu with .T., delrec with (.T.)
       SET FILTER to TRIM(word1)=='ON' .and. LEFT(word2, 4)=='SELE' .and. UPPER(LEFT(word3, 4))=='POPU' .and. TRIM(UPPER(word4))==M.ppup
       REPLACE curmenu with .T., delrec with (.T.)
       SET FILTER to TRIM(word1)=='ON' .and. LEFT(word2, 4)=='SELE' .and. UPPER(TRIM(word3))=='BAR' .and. TRIM(UPPER(word6))==M.ppup
       REPLACE curmenu with .T., delrec with (.T.)
       SET FILTER to TRIM(word1)=='SET' .and. TRIM(word2)=='MARK' .and. UPPER(TRIM(word3))=='OF' .and. UPPER(LEFT(word4, 4))=='POPU' .and. TRIM(UPPER(word5))==M.ppup
       REPLACE curmenu with .T., delrec with (.T.)
       SET FILTER to TRIM(word1)=='SET' .and. TRIM(word2)=='MARK' .and. UPPER(TRIM(word3))=='OF' .and. UPPER(TRIM(word4))=='BAR' .and. TRIM(UPPER(word7))==M.ppup
       REPLACE curmenu with .T., delrec with (.T.)
       SET FILTER to TRIM(word1)=='ON' .and. TRIM(word2)=='BAR' .and. TRIM(UPPER(word5))==M.ppup .and. (UPPER(LEFT(word6, 4))=='ACTI'  or UPPER(LEFT(word6, 3))=='PAD').and. UPPER(LEFT(word7, 4))=='POPU'
       REPLACE curmenu with .T., delrec with (.T.)
       GOTO top
       SCAN
          IF problem .or. LEN(TRIM(word8))=0
             LOOP
          ENDIF
          np_nxt = M.np_nxt+1
          DIMENSION pp_nxt( np_nxt)
          pp_nxt( M.np_nxt) = UPPER(TRIM(word8))
       ENDSCAN
    ENDFOR
    IF M.np_nxt=0
       EXIT
    ENDIF
    nppups = M.np_nxt
    DIMENSION ppups( M.np_nxt)
    = ACOPY(pp_nxt, ppups, 1, M.np_nxt)
 ENDDO
 RETURN
***** End *****
